Statistics
| Branch: | Tag: | Revision:

root / Makefile.am @ 09b72783

History | View | Annotate | Download (48.9 kB)

1 e8230860 Michael Hanselmann
# Ganeti makefile
2 e8230860 Michael Hanselmann
# - Indent with tabs only.
3 e8230860 Michael Hanselmann
# - Keep files sorted; one line per file.
4 e8230860 Michael Hanselmann
# - Directories in lib/ must have their own *dir variable (see hypervisor).
5 e8230860 Michael Hanselmann
# - All directories must be listed DIRS.
6 0a7bed64 Michael Hanselmann
# - Use autogen.sh to generate Makefile.in and configure script.
7 e8230860 Michael Hanselmann
8 e8230860 Michael Hanselmann
# Automake doesn't export these variables before version 1.10.
9 e8230860 Michael Hanselmann
abs_top_builddir = @abs_top_builddir@
10 e8230860 Michael Hanselmann
abs_top_srcdir = @abs_top_srcdir@
11 e8230860 Michael Hanselmann
12 08366664 Michael Hanselmann
# Helper values for calling builtin functions
13 08366664 Michael Hanselmann
empty :=
14 08366664 Michael Hanselmann
space := $(empty) $(empty)
15 08366664 Michael Hanselmann
comma := ,
16 08366664 Michael Hanselmann
17 a01dd3c6 Iustin Pop
# Use bash in order to be able to use pipefail
18 a01dd3c6 Iustin Pop
SHELL=/bin/bash
19 a01dd3c6 Iustin Pop
20 6e06b36c Iustin Pop
ACLOCAL_AMFLAGS = -I autotools
21 4f3d5b76 Michael Hanselmann
BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 b959138f Michael Hanselmann
RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 eed5c5df Michael Hanselmann
CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 5d3c30df Michael Hanselmann
CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 c55cc346 Iustin Pop
CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 73d0e218 Iustin Pop
CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 96602be4 Michael Hanselmann
CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 7385c51d Michael Hanselmann
CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 f6cbcc06 Michael Hanselmann
CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 95eb4188 Michael Hanselmann
DOCPP = $(top_srcdir)/autotools/docpp
31 e8230860 Michael Hanselmann
REPLACE_VARS_SED = autotools/replace_vars.sed
32 d99d1e36 Iustin Pop
CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 d5a2a550 Michael Hanselmann
BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 6e3bf290 Michael Hanselmann
SHELL_ENV_INIT = autotools/shell-env-init
35 e8230860 Michael Hanselmann
36 22c5390d Iustin Pop
# Note: these are automake-specific variables, and must be named after
37 22c5390d Iustin Pop
# the directory + 'dir' suffix
38 2d48a3a2 Michael Hanselmann
clientdir = $(pkgpythondir)/client
39 e8230860 Michael Hanselmann
hypervisordir = $(pkgpythondir)/hypervisor
40 ff9efc03 Michael Hanselmann
httpdir = $(pkgpythondir)/http
41 dc101ecc Michael Hanselmann
masterddir = $(pkgpythondir)/masterd
42 12426ae1 Guido Trotter
confddir = $(pkgpythondir)/confd
43 8c229cc7 Oleksiy Mishchenko
rapidir = $(pkgpythondir)/rapi
44 899c4d2c Michael Hanselmann
serverdir = $(pkgpythondir)/server
45 9f4bb951 Michael Hanselmann
watcherdir = $(pkgpythondir)/watcher
46 bb44b1ae Michael Hanselmann
impexpddir = $(pkgpythondir)/impexpd
47 c047a981 Michael Hanselmann
utilsdir = $(pkgpythondir)/utils
48 e8230860 Michael Hanselmann
toolsdir = $(pkglibdir)/tools
49 7617fd6b Iustin Pop
iallocatorsdir = $(pkglibdir)/iallocators
50 0d2bf835 René Nussbaumer
pytoolsdir = $(pkgpythondir)/tools
51 e8230860 Michael Hanselmann
docdir = $(datadir)/doc/$(PACKAGE)
52 b8fe7ca6 Iustin Pop
myexeclibdir = $(pkglibdir)
53 e8230860 Michael Hanselmann
54 a4f12da4 Michael Hanselmann
# Delete output file if an error occurred while building it
55 a4f12da4 Michael Hanselmann
.DELETE_ON_ERROR:
56 a4f12da4 Michael Hanselmann
57 d5506465 Iustin Pop
HTOOLS_DIRS = \
58 d5506465 Iustin Pop
	htools \
59 d5506465 Iustin Pop
	htools/Ganeti \
60 358a0a8f Iustin Pop
	htools/Ganeti/Confd \
61 458a286a Iustin Pop
	htools/Ganeti/HTools \
62 879d9290 Iustin Pop
	htools/Ganeti/HTools/Backend \
63 4cbe9bda Iustin Pop
	htools/Ganeti/HTools/Program \
64 f0f3a6df Iustin Pop
	htools/Ganeti/Query \
65 e5a29b6c Iustin Pop
	htest \
66 e5a29b6c Iustin Pop
	htest/Test \
67 2733df51 Iustin Pop
	htest/Test/Ganeti \
68 aed2325f Iustin Pop
	htest/Test/Ganeti/Confd \
69 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools \
70 879d9290 Iustin Pop
	htest/Test/Ganeti/HTools/Backend \
71 aed2325f Iustin Pop
	htest/Test/Ganeti/Query
72 d5506465 Iustin Pop
73 e8230860 Michael Hanselmann
DIRS = \
74 dad26941 Iustin Pop
	$(HTOOLS_DIRS) \
75 e8230860 Michael Hanselmann
	autotools \
76 e8230860 Michael Hanselmann
	daemons \
77 e8230860 Michael Hanselmann
	devel \
78 e8230860 Michael Hanselmann
	doc \
79 e8230860 Michael Hanselmann
	doc/examples \
80 c51580b3 Guido Trotter
	doc/examples/gnt-debug \
81 dad26941 Iustin Pop
	doc/examples/hooks \
82 dad26941 Iustin Pop
	htest/data \
83 dad26941 Iustin Pop
	htest/data/rapi \
84 dad26941 Iustin Pop
	htest/shelltests \
85 e8230860 Michael Hanselmann
	lib \
86 f9897b6d Michael Hanselmann
	lib/build \
87 dad26941 Iustin Pop
	lib/client \
88 2f16ea8f Michael Hanselmann
	lib/confd \
89 ff9efc03 Michael Hanselmann
	lib/http \
90 e8230860 Michael Hanselmann
	lib/hypervisor \
91 bb44b1ae Michael Hanselmann
	lib/impexpd \
92 dc101ecc Michael Hanselmann
	lib/masterd \
93 8c229cc7 Oleksiy Mishchenko
	lib/rapi \
94 899c4d2c Michael Hanselmann
	lib/server \
95 0d2bf835 René Nussbaumer
	lib/tools \
96 c047a981 Michael Hanselmann
	lib/utils \
97 9f4bb951 Michael Hanselmann
	lib/watcher \
98 e8230860 Michael Hanselmann
	man \
99 e8230860 Michael Hanselmann
	qa \
100 e8230860 Michael Hanselmann
	test \
101 e8230860 Michael Hanselmann
	test/data \
102 1e6fab60 Agata Murawska
	test/data/ovfdata \
103 d92518d3 Agata Murawska
	test/data/ovfdata/other \
104 e8230860 Michael Hanselmann
	tools
105 e8230860 Michael Hanselmann
106 2750b299 Michael Hanselmann
BUILDTIME_DIR_AUTOCREATE = \
107 c964d962 Michael Hanselmann
	scripts \
108 22c5390d Iustin Pop
	$(APIDOC_DIR) \
109 22c5390d Iustin Pop
	$(APIDOC_HS_DIR) \
110 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti \
111 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/Confd \
112 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools \
113 879d9290 Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
114 458a286a Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools/Program \
115 662de722 Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/Query \
116 dad26941 Iustin Pop
	$(APIDOC_PY_DIR) \
117 22c5390d Iustin Pop
	$(COVERAGE_DIR) \
118 22c5390d Iustin Pop
	$(COVERAGE_HS_DIR) \
119 dad26941 Iustin Pop
	$(COVERAGE_PY_DIR) \
120 b91e9518 Iustin Pop
	.hpc
121 2750b299 Michael Hanselmann
122 2750b299 Michael Hanselmann
BUILDTIME_DIRS = \
123 2750b299 Michael Hanselmann
	$(BUILDTIME_DIR_AUTOCREATE) \
124 6b997854 Michael Hanselmann
	doc/html
125 6b997854 Michael Hanselmann
126 6b997854 Michael Hanselmann
DIRCHECK_EXCLUDE = \
127 6b997854 Michael Hanselmann
	$(BUILDTIME_DIRS) \
128 6b997854 Michael Hanselmann
	ganeti-[0-9]*.[0-9]*.[0-9]* \
129 6b997854 Michael Hanselmann
	doc/html/_*
130 6b997854 Michael Hanselmann
131 22c5390d Iustin Pop
# some helper vars
132 22c5390d Iustin Pop
COVERAGE_DIR = doc/coverage
133 22c5390d Iustin Pop
COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
134 22c5390d Iustin Pop
COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
135 22c5390d Iustin Pop
APIDOC_DIR = doc/api
136 22c5390d Iustin Pop
APIDOC_PY_DIR = $(APIDOC_DIR)/py
137 22c5390d Iustin Pop
APIDOC_HS_DIR = $(APIDOC_DIR)/hs
138 22c5390d Iustin Pop
139 2ab2b9f5 Iustin Pop
MAINTAINERCLEANFILES = \
140 d17e74b4 Iustin Pop
	$(docpng) \
141 b76aac08 Michael Hanselmann
	$(maninput) \
142 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
143 84a12e40 Iustin Pop
	doc/news.rst \
144 7a03d293 Michael Hanselmann
	doc/upgrade.rst \
145 84a12e40 Iustin Pop
	vcs-version
146 2ab2b9f5 Iustin Pop
147 d17e74b4 Iustin Pop
maintainer-clean-local:
148 6b997854 Michael Hanselmann
	rm -rf $(BUILDTIME_DIRS)
149 d17e74b4 Iustin Pop
150 e8230860 Michael Hanselmann
CLEANFILES = \
151 2f16ea8f Michael Hanselmann
	$(addsuffix /*.py[co],$(DIRS)) \
152 d5506465 Iustin Pop
	$(addsuffix /*.hi,$(HTOOLS_DIRS)) \
153 d5506465 Iustin Pop
	$(addsuffix /*.o,$(HTOOLS_DIRS)) \
154 2d48a3a2 Michael Hanselmann
	$(PYTHON_BOOTSTRAP) \
155 f774bd03 Michael Hanselmann
	epydoc.conf \
156 5098afd1 Iustin Pop
	$(REPLACE_VARS_SED) \
157 6e3bf290 Michael Hanselmann
	$(SHELL_ENV_INIT) \
158 f154a7a3 Michael Hanselmann
	daemons/daemon-util \
159 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner \
160 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
161 f72f8622 Iustin Pop
	doc/examples/bash_completion \
162 e80aeb89 Michael Hanselmann
	doc/examples/bash_completion-debug \
163 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py \
164 2ab2b9f5 Iustin Pop
	$(man_MANS) \
165 2ab2b9f5 Iustin Pop
	$(manhtml) \
166 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
167 e5afb848 Michael Hanselmann
	tools/vcluster-setup \
168 3735787e Iustin Pop
	stamp-directories \
169 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
170 d6159933 Iustin Pop
	$(nodist_pkgpython_PYTHON) \
171 c3f67183 Iustin Pop
	$(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
172 3096524e Iustin Pop
	$(HS_BUILT_TEST_HELPERS) \
173 b0dcdc10 Iustin Pop
	htools/ganeti-confd \
174 f0f3a6df Iustin Pop
	.hpc/*.mix htools/*.tix htest/*.tix \
175 191ff68c Iustin Pop
	doc/hs-lint.html
176 e8230860 Michael Hanselmann
177 4c3d5fb6 Iustin Pop
GENERATED_FILES = \
178 5098afd1 Iustin Pop
	$(built_base_sources) \
179 96a7481d Michael Hanselmann
	$(BUILT_PYTHON_SOURCES) \
180 96a7481d Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
181 96a7481d Michael Hanselmann
182 ada0e680 Iustin Pop
HTOOLS_GENERATED_FILES =
183 ada0e680 Iustin Pop
if WANT_HTOOLS
184 ada0e680 Iustin Pop
HTOOLS_GENERATED_FILES += $(HS_PROGS)
185 04520998 Iustin Pop
if ENABLE_CONFD
186 f8d01158 Iustin Pop
HTOOLS_GENERATED_FILES += htools/hconfd htools/ganeti-confd
187 ada0e680 Iustin Pop
endif
188 ada0e680 Iustin Pop
endif
189 ada0e680 Iustin Pop
190 96a7481d Michael Hanselmann
built_base_sources = \
191 3735787e Iustin Pop
	stamp-directories \
192 3735787e Iustin Pop
	stamp-srclinks
193 2d1f248e Michael Hanselmann
194 96a7481d Michael Hanselmann
built_python_base_sources = \
195 13aeae6a Iustin Pop
	lib/_autoconf.py \
196 96a7481d Michael Hanselmann
	lib/_vcsversion.py
197 96a7481d Michael Hanselmann
198 96a7481d Michael Hanselmann
BUILT_PYTHON_SOURCES = \
199 96a7481d Michael Hanselmann
	$(built_python_base_sources) \
200 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py
201 e8230860 Michael Hanselmann
202 5098afd1 Iustin Pop
# Generating the RPC wrappers depends on many things, so make sure
203 5098afd1 Iustin Pop
# it's built at the end of the built sources
204 96a7481d Michael Hanselmann
lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
205 96a7481d Michael Hanselmann
206 656a7fdf Iustin Pop
# these are all built from the underlying %.in sources
207 656a7fdf Iustin Pop
BUILT_EXAMPLES = \
208 656a7fdf Iustin Pop
	doc/examples/ganeti-kvm-poweroff.initd \
209 656a7fdf Iustin Pop
	doc/examples/ganeti.cron \
210 656a7fdf Iustin Pop
	doc/examples/ganeti.initd \
211 656a7fdf Iustin Pop
	doc/examples/gnt-config-backup \
212 656a7fdf Iustin Pop
	doc/examples/hooks/ipsec
213 656a7fdf Iustin Pop
214 08366664 Michael Hanselmann
nodist_pkgpython_PYTHON = \
215 08366664 Michael Hanselmann
	$(BUILT_PYTHON_SOURCES)
216 08366664 Michael Hanselmann
217 f9897b6d Michael Hanselmann
noinst_PYTHON = \
218 5f43f393 Michael Hanselmann
	lib/build/__init__.py \
219 dad26941 Iustin Pop
	lib/build/shell_example_lexer.py \
220 dad26941 Iustin Pop
	lib/build/sphinx_ext.py
221 f9897b6d Michael Hanselmann
222 e8230860 Michael Hanselmann
pkgpython_PYTHON = \
223 e8230860 Michael Hanselmann
	lib/__init__.py \
224 a8a76bc2 Guido Trotter
	lib/asyncnotifier.py \
225 e8230860 Michael Hanselmann
	lib/backend.py \
226 e8230860 Michael Hanselmann
	lib/bdev.py \
227 e8230860 Michael Hanselmann
	lib/bootstrap.py \
228 e8230860 Michael Hanselmann
	lib/cli.py \
229 e8230860 Michael Hanselmann
	lib/cmdlib.py \
230 cea881e5 Michael Hanselmann
	lib/compat.py \
231 e8230860 Michael Hanselmann
	lib/config.py \
232 e8230860 Michael Hanselmann
	lib/constants.py \
233 821d9e43 Michael Hanselmann
	lib/daemon.py \
234 e8230860 Michael Hanselmann
	lib/errors.py \
235 62e0e880 Iustin Pop
	lib/ht.py \
236 e8230860 Michael Hanselmann
	lib/jqueue.py \
237 8b537bb0 Michael Hanselmann
	lib/jstore.py \
238 e8230860 Michael Hanselmann
	lib/locking.py \
239 e8230860 Michael Hanselmann
	lib/luxi.py \
240 e8230860 Michael Hanselmann
	lib/mcpu.py \
241 a744b676 Manuel Franceschini
	lib/netutils.py \
242 e8230860 Michael Hanselmann
	lib/objects.py \
243 32683096 René Nussbaumer
	lib/objectutils.py \
244 e8230860 Michael Hanselmann
	lib/opcodes.py \
245 ced78a66 Agata Murawska
	lib/ovf.py \
246 3329f4de Michael Hanselmann
	lib/pathutils.py \
247 a123dc19 Michael Hanselmann
	lib/qlang.py \
248 4ca96421 Michael Hanselmann
	lib/query.py \
249 e8230860 Michael Hanselmann
	lib/rpc.py \
250 6648cb36 Michael Hanselmann
	lib/rpc_defs.py \
251 f12e1736 René Nussbaumer
	lib/runtime.py \
252 e8230860 Michael Hanselmann
	lib/serializer.py \
253 e8230860 Michael Hanselmann
	lib/ssconf.py \
254 e8230860 Michael Hanselmann
	lib/ssh.py \
255 ac2d0fe4 Michael Hanselmann
	lib/storage.py \
256 1338f2b4 Balazs Lecz
	lib/uidpool.py \
257 05e733b4 Michael Hanselmann
	lib/vcluster.py \
258 76094e37 Michael Hanselmann
	lib/workerpool.py
259 e8230860 Michael Hanselmann
260 2d48a3a2 Michael Hanselmann
client_PYTHON = \
261 c2855a12 Michael Hanselmann
	lib/client/__init__.py \
262 02266fe0 Michael Hanselmann
	lib/client/gnt_backup.py \
263 7b3e7d41 Michael Hanselmann
	lib/client/gnt_cluster.py \
264 6d50f5f9 Michael Hanselmann
	lib/client/gnt_debug.py \
265 667dbd6b Adeodato Simo
	lib/client/gnt_group.py \
266 e792102d Michael Hanselmann
	lib/client/gnt_instance.py \
267 a09b9e3d Michael Hanselmann
	lib/client/gnt_job.py \
268 37494fa4 Michael Hanselmann
	lib/client/gnt_node.py \
269 6d50f5f9 Michael Hanselmann
	lib/client/gnt_os.py
270 2d48a3a2 Michael Hanselmann
271 e8230860 Michael Hanselmann
hypervisor_PYTHON = \
272 e8230860 Michael Hanselmann
	lib/hypervisor/__init__.py \
273 e8230860 Michael Hanselmann
	lib/hypervisor/hv_base.py \
274 48297fa2 Iustin Pop
	lib/hypervisor/hv_chroot.py \
275 e8230860 Michael Hanselmann
	lib/hypervisor/hv_fake.py \
276 eb58f9b1 Guido Trotter
	lib/hypervisor/hv_kvm.py \
277 4b5e40a5 Iustin Pop
	lib/hypervisor/hv_lxc.py \
278 e8230860 Michael Hanselmann
	lib/hypervisor/hv_xen.py
279 e8230860 Michael Hanselmann
280 8c229cc7 Oleksiy Mishchenko
rapi_PYTHON = \
281 8c229cc7 Oleksiy Mishchenko
	lib/rapi/__init__.py \
282 10b207d4 Oleksiy Mishchenko
	lib/rapi/baserlib.py \
283 95ab4de9 David Knowles
	lib/rapi/client.py \
284 20b509de Michael Hanselmann
	lib/rapi/client_utils.py \
285 10b207d4 Oleksiy Mishchenko
	lib/rapi/connector.py \
286 a85f23fa Michael Hanselmann
	lib/rapi/rlib2.py \
287 a85f23fa Michael Hanselmann
	lib/rapi/testutils.py
288 8c229cc7 Oleksiy Mishchenko
289 ff9efc03 Michael Hanselmann
http_PYTHON = \
290 02cab3e7 Michael Hanselmann
	lib/http/__init__.py \
291 be500c29 Michael Hanselmann
	lib/http/auth.py \
292 02cab3e7 Michael Hanselmann
	lib/http/client.py \
293 02cab3e7 Michael Hanselmann
	lib/http/server.py
294 ff9efc03 Michael Hanselmann
295 12426ae1 Guido Trotter
confd_PYTHON = \
296 71f27d19 Guido Trotter
	lib/confd/__init__.py \
297 b0dcdc10 Iustin Pop
	lib/confd/client.py
298 8c229cc7 Oleksiy Mishchenko
299 dc101ecc Michael Hanselmann
masterd_PYTHON = \
300 033a1d00 Michael Hanselmann
	lib/masterd/__init__.py \
301 0fcd0cad René Nussbaumer
	lib/masterd/iallocator.py \
302 033a1d00 Michael Hanselmann
	lib/masterd/instance.py
303 dc101ecc Michael Hanselmann
304 bb44b1ae Michael Hanselmann
impexpd_PYTHON = \
305 bb44b1ae Michael Hanselmann
	lib/impexpd/__init__.py
306 bb44b1ae Michael Hanselmann
307 9f4bb951 Michael Hanselmann
watcher_PYTHON = \
308 9ca87fb3 Michael Hanselmann
	lib/watcher/__init__.py \
309 adf6301e Michael Hanselmann
	lib/watcher/nodemaint.py \
310 adf6301e Michael Hanselmann
	lib/watcher/state.py
311 9f4bb951 Michael Hanselmann
312 899c4d2c Michael Hanselmann
server_PYTHON = \
313 29d91329 Michael Hanselmann
	lib/server/__init__.py \
314 5119f2ec Michael Hanselmann
	lib/server/masterd.py \
315 d9c82a4e Michael Hanselmann
	lib/server/noded.py \
316 d9c82a4e Michael Hanselmann
	lib/server/rapi.py
317 899c4d2c Michael Hanselmann
318 0d2bf835 René Nussbaumer
pytools_PYTHON = \
319 0d2bf835 René Nussbaumer
	lib/tools/__init__.py \
320 d12b9f66 Michael Hanselmann
	lib/tools/ensure_dirs.py \
321 d12b9f66 Michael Hanselmann
	lib/tools/prepare_node_join.py
322 0d2bf835 René Nussbaumer
323 c047a981 Michael Hanselmann
utils_PYTHON = \
324 4fd029cf Michael Hanselmann
	lib/utils/__init__.py \
325 79d22269 Michael Hanselmann
	lib/utils/algo.py \
326 9d1b963f Michael Hanselmann
	lib/utils/filelock.py \
327 f21bb4b7 Michael Hanselmann
	lib/utils/hash.py \
328 3865ca48 Michael Hanselmann
	lib/utils/io.py \
329 1ae4c5a1 Michael Hanselmann
	lib/utils/log.py \
330 8dc76d54 Guido Trotter
	lib/utils/mlock.py \
331 17b97ab3 Michael Hanselmann
	lib/utils/nodesetup.py \
332 a4ccecf6 Michael Hanselmann
	lib/utils/process.py \
333 7fcffe27 Michael Hanselmann
	lib/utils/retry.py \
334 7831fc5f Michael Hanselmann
	lib/utils/text.py \
335 c50645c0 Michael Hanselmann
	lib/utils/wrapper.py \
336 c50645c0 Michael Hanselmann
	lib/utils/x509.py
337 c047a981 Michael Hanselmann
338 f05c99f3 Michael Hanselmann
docrst = \
339 ffa6869f Iustin Pop
	doc/admin.rst \
340 dad26941 Iustin Pop
	doc/cluster-merge.rst \
341 5c0c1eeb Iustin Pop
	doc/design-2.0.rst \
342 4f366caf Michael Hanselmann
	doc/design-2.1.rst \
343 e56bb0e8 Guido Trotter
	doc/design-2.2.rst \
344 1eb85930 Guido Trotter
	doc/design-2.3.rst \
345 78b40c5e Michael Hanselmann
	doc/design-2.4.rst \
346 d774ce92 Michael Hanselmann
	doc/design-2.5.rst \
347 40309ed7 Michael Hanselmann
	doc/design-2.6.rst \
348 97aac894 Michael Hanselmann
	doc/design-2.7.rst \
349 dad26941 Iustin Pop
	doc/design-autorepair.rst \
350 dad26941 Iustin Pop
	doc/design-bulk-create.rst \
351 dad26941 Iustin Pop
	doc/design-chained-jobs.rst \
352 ae9b5e0f Tsachy Shacham
	doc/design-cpu-pinning.rst \
353 dad26941 Iustin Pop
	doc/design-draft.rst \
354 dad26941 Iustin Pop
	doc/design-htools-2.3.rst \
355 278ddaa9 Michael Hanselmann
	doc/design-http-server.rst \
356 1375e1d9 Michael Hanselmann
	doc/design-impexp2.rst \
357 ed9fda24 Michael Hanselmann
	doc/design-lu-generated-jobs.rst \
358 d55b80b0 Guido Trotter
	doc/design-linuxha.rst \
359 4055b109 Adeodato Simo
	doc/design-multi-reloc.rst \
360 eec83a95 Apollon Oikonomopoulos
	doc/design-network.rst \
361 dad26941 Iustin Pop
	doc/design-oob.rst \
362 64ea845e Michael Hanselmann
	doc/design-ovf-support.rst \
363 dad26941 Iustin Pop
	doc/design-partitioned.rst \
364 dad26941 Iustin Pop
	doc/design-query-splitting.rst \
365 dad26941 Iustin Pop
	doc/design-query2.rst \
366 2ff01d78 Michael Hanselmann
	doc/design-remote-commands.rst \
367 d85f01e7 Iustin Pop
	doc/design-resource-model.rst \
368 a997cec5 Apollon Oikonomopoulos
	doc/design-shared-storage.rst \
369 f98efa98 Michael Hanselmann
	doc/design-ssh-setup.rst \
370 109e07c2 Guido Trotter
	doc/design-monitoring-agent.rst \
371 6b898285 Iustin Pop
	doc/design-virtual-clusters.rst \
372 dad26941 Iustin Pop
	doc/design-x509-ca.rst \
373 62947ebb Michael Hanselmann
	doc/devnotes.rst \
374 e2078d28 Iustin Pop
	doc/glossary.rst \
375 4d6443f4 Iustin Pop
	doc/hooks.rst \
376 876860a3 Iustin Pop
	doc/iallocator.rst \
377 d17e74b4 Iustin Pop
	doc/index.rst \
378 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
379 28e15341 Iustin Pop
	doc/install.rst \
380 9725b53d Michael Hanselmann
	doc/locking.rst \
381 6bf273d5 Michael Hanselmann
	doc/move-instance.rst \
382 c71a1a3d Iustin Pop
	doc/news.rst \
383 a47dc554 René Nussbaumer
	doc/ovfconverter.rst \
384 6d81475c Iustin Pop
	doc/rapi.rst \
385 b76aac08 Michael Hanselmann
	doc/security.rst \
386 35dd762d Michael Hanselmann
	doc/upgrade.rst \
387 ab171697 Michael Hanselmann
	doc/virtual-cluster.rst \
388 c71a1a3d Iustin Pop
	doc/walkthrough.rst
389 f05c99f3 Michael Hanselmann
390 0985325d Iustin Pop
HS_PROGS = htools/htools
391 22e513e7 Agata Murawska
HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
392 ada0e680 Iustin Pop
HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
393 d6159933 Iustin Pop
394 19e21a6c Iustin Pop
HS_ALL_PROGS = \
395 19e21a6c Iustin Pop
	$(HS_PROGS) \
396 19e21a6c Iustin Pop
	htest/hpc-htools \
397 19e21a6c Iustin Pop
	htest/test \
398 19e21a6c Iustin Pop
	htools/hconfd \
399 19e21a6c Iustin Pop
	htools/rpc-test
400 19e21a6c Iustin Pop
401 c3f67183 Iustin Pop
HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
402 189b51fa Iustin Pop
HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
403 3096524e Iustin Pop
404 74e60746 Iustin Pop
HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
405 74e60746 Iustin Pop
# extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
406 d6159933 Iustin Pop
HEXTRA =
407 f0f3a6df Iustin Pop
# internal extra flags (used for htest/test mainly)
408 c7ec3025 Iustin Pop
HEXTRA_INT =
409 b91e9518 Iustin Pop
# exclude options for coverage reports
410 9822b1dd Iustin Pop
HPCEXCL = --exclude Main \
411 98b33d0e Iustin Pop
	--exclude Ganeti.Constants \
412 9822b1dd Iustin Pop
	--exclude Ganeti.HTools.QC \
413 dad26941 Iustin Pop
	--exclude Ganeti.THH \
414 2997cb0a Iustin Pop
	--exclude Ganeti.Version \
415 2733df51 Iustin Pop
	--exclude Test.Ganeti.TestCommon \
416 e1ee7d5a Iustin Pop
	--exclude Test.Ganeti.TestHTools \
417 e1ee7d5a Iustin Pop
	--exclude Test.Ganeti.TestHelper \
418 b88fcdd0 Iustin Pop
	--exclude Test.Ganeti.TestImports \
419 51309138 Iustin Pop
	$(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
420 d6159933 Iustin Pop
421 c3f67183 Iustin Pop
HS_LIB_SRCS = \
422 dad26941 Iustin Pop
	htools/Ganeti/BasicTypes.hs \
423 dad26941 Iustin Pop
	htools/Ganeti/Common.hs \
424 dad26941 Iustin Pop
	htools/Ganeti/Compat.hs \
425 dad26941 Iustin Pop
	htools/Ganeti/Confd/Server.hs \
426 cdc2392b Iustin Pop
	htools/Ganeti/Confd/Types.hs \
427 dad26941 Iustin Pop
	htools/Ganeti/Confd/Utils.hs \
428 dad26941 Iustin Pop
	htools/Ganeti/Config.hs \
429 dad26941 Iustin Pop
	htools/Ganeti/Daemon.hs \
430 ef3ad027 Iustin Pop
	htools/Ganeti/Errors.hs \
431 879d9290 Iustin Pop
	htools/Ganeti/HTools/Backend/IAlloc.hs \
432 879d9290 Iustin Pop
	htools/Ganeti/HTools/Backend/Luxi.hs \
433 879d9290 Iustin Pop
	htools/Ganeti/HTools/Backend/Rapi.hs \
434 879d9290 Iustin Pop
	htools/Ganeti/HTools/Backend/Simu.hs \
435 879d9290 Iustin Pop
	htools/Ganeti/HTools/Backend/Text.hs \
436 d6159933 Iustin Pop
	htools/Ganeti/HTools/CLI.hs \
437 d6159933 Iustin Pop
	htools/Ganeti/HTools/Cluster.hs \
438 d6159933 Iustin Pop
	htools/Ganeti/HTools/Container.hs \
439 d6159933 Iustin Pop
	htools/Ganeti/HTools/ExtLoader.hs \
440 d6159933 Iustin Pop
	htools/Ganeti/HTools/Group.hs \
441 d6159933 Iustin Pop
	htools/Ganeti/HTools/Instance.hs \
442 d6159933 Iustin Pop
	htools/Ganeti/HTools/Loader.hs \
443 d6159933 Iustin Pop
	htools/Ganeti/HTools/Node.hs \
444 d6159933 Iustin Pop
	htools/Ganeti/HTools/PeerMap.hs \
445 9f13be88 Iustin Pop
	htools/Ganeti/HTools/Program.hs \
446 458a286a Iustin Pop
	htools/Ganeti/HTools/Program/Hail.hs \
447 201b6c34 Iustin Pop
	htools/Ganeti/HTools/Program/Hbal.hs \
448 22e513e7 Agata Murawska
	htools/Ganeti/HTools/Program/Hcheck.hs \
449 2922d2c5 René Nussbaumer
	htools/Ganeti/HTools/Program/Hinfo.hs \
450 7b695a0d Iustin Pop
	htools/Ganeti/HTools/Program/Hscan.hs \
451 1494a4cc Iustin Pop
	htools/Ganeti/HTools/Program/Hspace.hs \
452 dad26941 Iustin Pop
	htools/Ganeti/HTools/Types.hs \
453 21dc8694 Iustin Pop
	htools/Ganeti/Hash.hs \
454 f3baf5ef Iustin Pop
	htools/Ganeti/JSON.hs \
455 dad26941 Iustin Pop
	htools/Ganeti/Jobs.hs \
456 ba4e38e8 Iustin Pop
	htools/Ganeti/Logging.hs \
457 d6159933 Iustin Pop
	htools/Ganeti/Luxi.hs \
458 b1e81520 Iustin Pop
	htools/Ganeti/Objects.hs \
459 e9aaa3c6 Iustin Pop
	htools/Ganeti/OpCodes.hs \
460 9eeb0aa5 Michael Hanselmann
	htools/Ganeti/Path.hs \
461 046fe3f5 Iustin Pop
	htools/Ganeti/Query/Common.hs \
462 8a65c02b Iustin Pop
	htools/Ganeti/Query/Filter.hs \
463 40246fa0 Agata Murawska
	htools/Ganeti/Query/Group.hs \
464 4cab6703 Iustin Pop
	htools/Ganeti/Query/Language.hs \
465 046fe3f5 Iustin Pop
	htools/Ganeti/Query/Node.hs \
466 4cbe9bda Iustin Pop
	htools/Ganeti/Query/Query.hs \
467 4cab6703 Iustin Pop
	htools/Ganeti/Query/Server.hs \
468 046fe3f5 Iustin Pop
	htools/Ganeti/Query/Types.hs \
469 4cab6703 Iustin Pop
	htools/Ganeti/Rpc.hs \
470 7946c25d Iustin Pop
	htools/Ganeti/Runtime.hs \
471 aa3adf35 Iustin Pop
	htools/Ganeti/Ssconf.hs \
472 26d62e4c Iustin Pop
	htools/Ganeti/THH.hs \
473 26d62e4c Iustin Pop
	htools/Ganeti/Utils.hs
474 51309138 Iustin Pop
475 51309138 Iustin Pop
HS_TEST_SRCS = \
476 1493a93b Iustin Pop
	htest/Test/Ganeti/BasicTypes.hs \
477 51000365 Iustin Pop
	htest/Test/Ganeti/Common.hs \
478 305e174c Iustin Pop
	htest/Test/Ganeti/Confd/Utils.hs \
479 dad26941 Iustin Pop
	htest/Test/Ganeti/Daemon.hs \
480 ef3ad027 Iustin Pop
	htest/Test/Ganeti/Errors.hs \
481 879d9290 Iustin Pop
	htest/Test/Ganeti/HTools/Backend/Simu.hs \
482 879d9290 Iustin Pop
	htest/Test/Ganeti/HTools/Backend/Text.hs \
483 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/CLI.hs \
484 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Cluster.hs \
485 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Container.hs \
486 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Instance.hs \
487 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Loader.hs \
488 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Node.hs \
489 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/PeerMap.hs \
490 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Types.hs \
491 2d87bd0a Iustin Pop
	htest/Test/Ganeti/JSON.hs \
492 2d87bd0a Iustin Pop
	htest/Test/Ganeti/Jobs.hs \
493 aed2325f Iustin Pop
	htest/Test/Ganeti/Luxi.hs \
494 2733df51 Iustin Pop
	htest/Test/Ganeti/Objects.hs \
495 aed2325f Iustin Pop
	htest/Test/Ganeti/OpCodes.hs \
496 90171729 Iustin Pop
	htest/Test/Ganeti/Query/Filter.hs \
497 aed2325f Iustin Pop
	htest/Test/Ganeti/Query/Language.hs \
498 b9bdc10e Iustin Pop
	htest/Test/Ganeti/Query/Query.hs \
499 aed2325f Iustin Pop
	htest/Test/Ganeti/Rpc.hs \
500 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/Ssconf.hs \
501 f51eacf3 Iustin Pop
	htest/Test/Ganeti/THH.hs \
502 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/TestCommon.hs \
503 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/TestHTools.hs \
504 26d62e4c Iustin Pop
	htest/Test/Ganeti/TestHelper.hs \
505 26d62e4c Iustin Pop
	htest/Test/Ganeti/Utils.hs
506 e4cc4c11 Iustin Pop
507 51309138 Iustin Pop
HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
508 d6159933 Iustin Pop
509 b88fcdd0 Iustin Pop
HS_BUILT_SRCS = \
510 b88fcdd0 Iustin Pop
	htest/Test/Ganeti/TestImports.hs \
511 b88fcdd0 Iustin Pop
	htools/Ganeti/Constants.hs \
512 2997cb0a Iustin Pop
	htools/Ganeti/Version.hs
513 c3f67183 Iustin Pop
HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
514 d6159933 Iustin Pop
515 3735787e Iustin Pop
$(RUN_IN_TEMPDIR): | stamp-directories
516 c964d962 Michael Hanselmann
517 a2d917f3 Iustin Pop
# Note: we use here an order-only prerequisite, as the contents of
518 a2d917f3 Iustin Pop
# _autoconf.py are not actually influencing the html build output: it
519 a2d917f3 Iustin Pop
# has to exist in order for the sphinx module to be loaded
520 a2d917f3 Iustin Pop
# successfully, but we certainly don't want the docs to be rebuilt if
521 a2d917f3 Iustin Pop
# it changes
522 c964d962 Michael Hanselmann
doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
523 7142485a Iustin Pop
	$(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
524 7142485a Iustin Pop
	lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
525 08366664 Michael Hanselmann
	| $(BUILT_PYTHON_SOURCES)
526 d17e74b4 Iustin Pop
	@test -n "$(SPHINX)" || \
527 d17e74b4 Iustin Pop
	    { echo 'sphinx-build' not found during configure; exit 1; }
528 2750b299 Michael Hanselmann
	@mkdir_p@ $(dir $@)
529 e7f6524c Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
530 13de7d59 Michael Hanselmann
	    -d . \
531 d17e74b4 Iustin Pop
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
532 d17e74b4 Iustin Pop
	    -D release="$(PACKAGE_VERSION)" \
533 13de7d59 Michael Hanselmann
	    $(abs_top_srcdir)/doc $(CURDIR)/doc/html
534 13de7d59 Michael Hanselmann
	rm -f doc/html/.buildinfo doc/html/objects.inv
535 13de7d59 Michael Hanselmann
	touch $@
536 13de7d59 Michael Hanselmann
537 c964d962 Michael Hanselmann
doc/html: doc/html/index.html
538 2ab2b9f5 Iustin Pop
539 cbf3d64b Michael Hanselmann
doc/install-quick.rst: INSTALL
540 b76aac08 Michael Hanselmann
doc/news.rst: NEWS
541 7a03d293 Michael Hanselmann
doc/upgrade.rst: UPGRADE
542 b76aac08 Michael Hanselmann
543 e8deef56 Michael Hanselmann
doc/install-quick.rst doc/news.rst doc/upgrade.rst:
544 cbf3d64b Michael Hanselmann
	set -e; \
545 cbf3d64b Michael Hanselmann
	{ echo '.. This file is automatically updated at build time from $<.'; \
546 cbf3d64b Michael Hanselmann
	  echo '.. Do not edit.'; \
547 cbf3d64b Michael Hanselmann
	  echo; \
548 cbf3d64b Michael Hanselmann
	  cat $<; \
549 cbf3d64b Michael Hanselmann
	} > $@
550 cbf3d64b Michael Hanselmann
551 b8195800 Iustin Pop
docdot = \
552 ca9ccea8 Michael Hanselmann
	doc/arch-2.0.dot \
553 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-acquire.dot \
554 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-release.dot
555 b8195800 Iustin Pop
556 d17e74b4 Iustin Pop
docpng = $(patsubst %.dot,%.png,$(docdot))
557 e8230860 Michael Hanselmann
558 7e1ccbe0 Michael Hanselmann
# Things to build but not to install (add it to EXTRA_DIST if it should be
559 7e1ccbe0 Michael Hanselmann
# distributed)
560 7e1ccbe0 Michael Hanselmann
noinst_DATA = \
561 7e1ccbe0 Michael Hanselmann
	doc/html \
562 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
563 7e1ccbe0 Michael Hanselmann
	doc/examples/bash_completion \
564 e80aeb89 Michael Hanselmann
	doc/examples/bash_completion-debug \
565 7e1ccbe0 Michael Hanselmann
	$(manhtml)
566 f29266b4 Iustin Pop
567 4f3d5b76 Michael Hanselmann
gnt_scripts = \
568 e8230860 Michael Hanselmann
	scripts/gnt-backup \
569 e8230860 Michael Hanselmann
	scripts/gnt-cluster \
570 e8230860 Michael Hanselmann
	scripts/gnt-debug \
571 667dbd6b Adeodato Simo
	scripts/gnt-group \
572 e8230860 Michael Hanselmann
	scripts/gnt-instance \
573 e8230860 Michael Hanselmann
	scripts/gnt-job \
574 e8230860 Michael Hanselmann
	scripts/gnt-node \
575 e8230860 Michael Hanselmann
	scripts/gnt-os
576 e8230860 Michael Hanselmann
577 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP_SBIN = \
578 29d91329 Michael Hanselmann
	daemons/ganeti-masterd \
579 5119f2ec Michael Hanselmann
	daemons/ganeti-noded \
580 d9c82a4e Michael Hanselmann
	daemons/ganeti-rapi \
581 dad26941 Iustin Pop
	daemons/ganeti-watcher \
582 656a7fdf Iustin Pop
	$(gnt_scripts)
583 2d48a3a2 Michael Hanselmann
584 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP = \
585 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
586 d12b9f66 Michael Hanselmann
	tools/ensure-dirs \
587 d12b9f66 Michael Hanselmann
	tools/prepare-node-join
588 0d2bf835 René Nussbaumer
589 a8c68e44 Michael Hanselmann
qa_scripts = \
590 a0c3e726 Michael Hanselmann
	qa/__init__.py \
591 a8c68e44 Michael Hanselmann
	qa/ganeti-qa.py \
592 a8c68e44 Michael Hanselmann
	qa/qa_cluster.py \
593 a8c68e44 Michael Hanselmann
	qa/qa_config.py \
594 a8c68e44 Michael Hanselmann
	qa/qa_daemon.py \
595 a8c68e44 Michael Hanselmann
	qa/qa_env.py \
596 a8c68e44 Michael Hanselmann
	qa/qa_error.py \
597 21bf2e2e Andrea Spadaccini
	qa/qa_group.py \
598 a8c68e44 Michael Hanselmann
	qa/qa_instance.py \
599 09470dd8 Michael Hanselmann
	qa/qa_job.py \
600 a8c68e44 Michael Hanselmann
	qa/qa_node.py \
601 a8c68e44 Michael Hanselmann
	qa/qa_os.py \
602 a8c68e44 Michael Hanselmann
	qa/qa_rapi.py \
603 a8c68e44 Michael Hanselmann
	qa/qa_tags.py \
604 a8c68e44 Michael Hanselmann
	qa/qa_utils.py
605 a8c68e44 Michael Hanselmann
606 d6159933 Iustin Pop
bin_SCRIPTS =
607 d6159933 Iustin Pop
if WANT_HTOOLS
608 c3f67183 Iustin Pop
bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
609 458a286a Iustin Pop
install-exec-hook:
610 458a286a Iustin Pop
	@mkdir_p@ $(DESTDIR)$(iallocatorsdir)
611 7fa52acd Iustin Pop
# FIXME: this is a hardcoded logic, instead of auto-resolving
612 7fa52acd Iustin Pop
	$(LN_S) -f ../../../bin/htools \
613 458a286a Iustin Pop
		   $(DESTDIR)$(iallocatorsdir)/hail
614 201b6c34 Iustin Pop
	for role in $(HS_BIN_ROLES); do \
615 7fa52acd Iustin Pop
		$(LN_S) -f htools \
616 201b6c34 Iustin Pop
			   $(DESTDIR)$(bindir)/$$role ; \
617 201b6c34 Iustin Pop
	done
618 d6159933 Iustin Pop
endif
619 d6159933 Iustin Pop
620 51309138 Iustin Pop
$(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
621 21a5e56c Iustin Pop
	@if [ "$(notdir $@)" = "test" ] && [ "$(HTOOLS_NODEV)" ]; then \
622 21a5e56c Iustin Pop
	  echo "Error: cannot run unittests without the development" \
623 21a5e56c Iustin Pop
	       " libraries (see devnotes.rst)" 1>&2; \
624 fd0bc853 Iustin Pop
	  exit 1; \
625 49e11c49 Iustin Pop
	fi
626 f0f3a6df Iustin Pop
	@rm -f $(notdir $@).tix
627 f0f3a6df Iustin Pop
	$(GHC) --make \
628 ef958f2a Iustin Pop
	  $(HFLAGS) \
629 21a5e56c Iustin Pop
	  $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
630 f0f3a6df Iustin Pop
	  -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
631 c7ec3025 Iustin Pop
	  $(HEXTRA) $(HEXTRA_INT) $@
632 70b6c284 Iustin Pop
	@touch "$@"
633 70b6c284 Iustin Pop
634 f0f3a6df Iustin Pop
# for the htest/test binary, we need to enable profiling/coverage
635 f0f3a6df Iustin Pop
htest/test: HEXTRA_INT=-fhpc -ihtest
636 b91e9518 Iustin Pop
637 896b2850 Iustin Pop
# we compile the hpc-htools binary with the program coverage
638 f0f3a6df Iustin Pop
htest/hpc-htools: HEXTRA_INT=-fhpc
639 25cdf177 Iustin Pop
640 04d15e63 Iustin Pop
# test dependency
641 f0f3a6df Iustin Pop
htest/offline-tests.sh: htest/hpc-htools
642 04d15e63 Iustin Pop
643 c7ec3025 Iustin Pop
# rules for building profiling-enabled versions of the haskell
644 c7ec3025 Iustin Pop
# programs: hs-prof does the full two-step build, whereas
645 c7ec3025 Iustin Pop
# hs-prof-quick does only the final rebuild (hs-prof must have been
646 c7ec3025 Iustin Pop
# run before)
647 c7ec3025 Iustin Pop
.PHONY: hs-prof hs-prof-quick
648 c7ec3025 Iustin Pop
hs-prof:
649 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) clean
650 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
651 c7ec3025 Iustin Pop
	rm -f $(HS_ALL_PROGS)
652 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
653 c7ec3025 Iustin Pop
654 c7ec3025 Iustin Pop
hs-prof-quick:
655 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
656 c7ec3025 Iustin Pop
657 da7e44ee Michael Hanselmann
dist_sbin_SCRIPTS = \
658 da7e44ee Michael Hanselmann
	tools/ganeti-listrunner
659 4f3d5b76 Michael Hanselmann
660 fc3fd894 Michael Hanselmann
nodist_sbin_SCRIPTS = \
661 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
662 46118ed2 Iustin Pop
	daemons/ganeti-cleaner
663 fc3fd894 Michael Hanselmann
664 04520998 Iustin Pop
if ENABLE_CONFD
665 b0dcdc10 Iustin Pop
htools/ganeti-confd: htools/hconfd
666 b0dcdc10 Iustin Pop
	cp -f $< $@
667 b0dcdc10 Iustin Pop
668 b0dcdc10 Iustin Pop
nodist_sbin_SCRIPTS += htools/ganeti-confd
669 73b0fa69 Iustin Pop
endif
670 73b0fa69 Iustin Pop
671 cc120286 Bernardo Dal Seno
python_scripts = \
672 e8230860 Michael Hanselmann
	tools/burnin \
673 e8230860 Michael Hanselmann
	tools/cfgshell \
674 e8230860 Michael Hanselmann
	tools/cfgupgrade \
675 b5672ea0 Iustin Pop
	tools/cfgupgrade12 \
676 1f7d3f7d René Nussbaumer
	tools/cluster-merge \
677 4ef0399b Iustin Pop
	tools/confd-client \
678 d62cbd3a Michael Hanselmann
	tools/fmtjson \
679 ea5fd476 Iustin Pop
	tools/lvmstrap \
680 6bf273d5 Michael Hanselmann
	tools/move-instance \
681 ced78a66 Agata Murawska
	tools/ovfconverter \
682 8a670753 Michael Hanselmann
	tools/sanitize-config
683 e8230860 Michael Hanselmann
684 61631293 Stephen Shirley
dist_tools_SCRIPTS = \
685 cc120286 Bernardo Dal Seno
	$(python_scripts) \
686 2f4c951e Stephen Shirley
	tools/kvm-console-wrapper \
687 dad26941 Iustin Pop
	tools/master-ip-setup \
688 b9612abb Iustin Pop
	tools/xen-console-wrapper
689 61631293 Stephen Shirley
690 29386d3e Michael Hanselmann
nodist_tools_SCRIPTS = \
691 29386d3e Michael Hanselmann
	tools/vcluster-setup
692 29386d3e Michael Hanselmann
693 2d76b580 Michael Hanselmann
pkglib_python_scripts = \
694 c6ccba7e Michael Hanselmann
	daemons/import-export \
695 c6ccba7e Michael Hanselmann
	tools/check-cert-expired
696 2d76b580 Michael Hanselmann
697 0d2bf835 René Nussbaumer
nodist_pkglib_python_scripts = \
698 d12b9f66 Michael Hanselmann
	tools/ensure-dirs \
699 d12b9f66 Michael Hanselmann
	tools/prepare-node-join
700 0d2bf835 René Nussbaumer
701 b8fe7ca6 Iustin Pop
myexeclib_SCRIPTS = \
702 2d76b580 Michael Hanselmann
	daemons/daemon-util \
703 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
704 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts)
705 f154a7a3 Michael Hanselmann
706 b8fe7ca6 Iustin Pop
nodist_myexeclib_SCRIPTS = \
707 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts)
708 0d2bf835 René Nussbaumer
709 e8230860 Michael Hanselmann
EXTRA_DIST = \
710 e8230860 Michael Hanselmann
	NEWS \
711 7a03d293 Michael Hanselmann
	UPGRADE \
712 f774bd03 Michael Hanselmann
	epydoc.conf.in \
713 70c771f6 Michael Hanselmann
	pylintrc \
714 bb46a96c Michael Hanselmann
	autotools/build-bash-completion \
715 d5a2a550 Michael Hanselmann
	autotools/build-rpc \
716 5d3c30df Michael Hanselmann
	autotools/check-header \
717 f6cbcc06 Michael Hanselmann
	autotools/check-imports \
718 c55cc346 Iustin Pop
	autotools/check-man-dashes \
719 73d0e218 Iustin Pop
	autotools/check-man-warnings \
720 c81ed2b2 Michael Hanselmann
	autotools/check-news \
721 dad26941 Iustin Pop
	autotools/check-python-code \
722 e627fe09 Michael Hanselmann
	autotools/check-tar \
723 96602be4 Michael Hanselmann
	autotools/check-version \
724 d99d1e36 Iustin Pop
	autotools/convert-constants \
725 95eb4188 Michael Hanselmann
	autotools/docpp \
726 27e336af Michael Hanselmann
	autotools/gen-coverage \
727 df69e0a0 Bernardo Dal Seno
	autotools/testrunner \
728 387863a5 Iustin Pop
	autotools/wrong-hardcoded-paths \
729 f3313af5 Guido Trotter
	$(RUN_IN_TEMPDIR) \
730 f154a7a3 Michael Hanselmann
	daemons/daemon-util.in \
731 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner.in \
732 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
733 f9435bdc Iustin Pop
	devel/upload \
734 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup.in \
735 29386d3e Michael Hanselmann
	tools/vcluster-setup.in \
736 b8195800 Iustin Pop
	$(docdot) \
737 f727d134 Michael Hanselmann
	$(docpng) \
738 d17e74b4 Iustin Pop
	$(docrst) \
739 d17e74b4 Iustin Pop
	doc/conf.py \
740 d17e74b4 Iustin Pop
	doc/html \
741 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES:%=%.in) \
742 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default \
743 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default-debug \
744 d6d9ce45 Guido Trotter
	doc/examples/hooks/ethers \
745 89c04c2d Guido Trotter
	doc/examples/gnt-debug/README \
746 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay0.json \
747 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay50.json \
748 e4d452b4 Michael Hanselmann
	test/lockperf.py \
749 e8230860 Michael Hanselmann
	test/testutils.py \
750 e8230860 Michael Hanselmann
	test/mocks.py \
751 e8230860 Michael Hanselmann
	$(dist_TESTS) \
752 e8230860 Michael Hanselmann
	$(TEST_FILES) \
753 6be8e2bf Iustin Pop
	man/footer.rst \
754 6be8e2bf Iustin Pop
	$(manrst) \
755 f727d134 Michael Hanselmann
	$(maninput) \
756 39e0d19e Michael Hanselmann
	qa/qa-sample.json \
757 d6159933 Iustin Pop
	$(qa_scripts) \
758 51309138 Iustin Pop
	$(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
759 5a1e31b4 Iustin Pop
	$(HS_PROG_SRCS) \
760 04d15e63 Iustin Pop
	htools/lint-hints.hs \
761 f0f3a6df Iustin Pop
	htest/cli-tests-defs.sh \
762 7a07475f Iustin Pop
	htest/offline-test.sh \
763 7a07475f Iustin Pop
	.ghci
764 e8230860 Michael Hanselmann
765 e8230860 Michael Hanselmann
man_MANS = \
766 bae7e531 Michael Hanselmann
	man/ganeti-cleaner.8 \
767 b7b7cda6 Guido Trotter
	man/ganeti-confd.8 \
768 da7e44ee Michael Hanselmann
	man/ganeti-listrunner.8 \
769 320d986d Iustin Pop
	man/ganeti-masterd.8 \
770 e8230860 Michael Hanselmann
	man/ganeti-noded.8 \
771 e8230860 Michael Hanselmann
	man/ganeti-os-interface.7 \
772 320d986d Iustin Pop
	man/ganeti-rapi.8 \
773 e8230860 Michael Hanselmann
	man/ganeti-watcher.8 \
774 dad26941 Iustin Pop
	man/ganeti.7 \
775 e8230860 Michael Hanselmann
	man/gnt-backup.8 \
776 e8230860 Michael Hanselmann
	man/gnt-cluster.8 \
777 d3b4cf9f Iustin Pop
	man/gnt-debug.8 \
778 667dbd6b Adeodato Simo
	man/gnt-group.8 \
779 e8230860 Michael Hanselmann
	man/gnt-instance.8 \
780 d3b4cf9f Iustin Pop
	man/gnt-job.8 \
781 e8230860 Michael Hanselmann
	man/gnt-node.8 \
782 5a19bd35 Iustin Pop
	man/gnt-os.8 \
783 5a19bd35 Iustin Pop
	man/hail.1 \
784 5a19bd35 Iustin Pop
	man/hbal.1 \
785 f18e4168 Iustin Pop
	man/hcheck.1 \
786 e2bdaf25 René Nussbaumer
	man/hinfo.1 \
787 5a19bd35 Iustin Pop
	man/hscan.1 \
788 d26d808a Iustin Pop
	man/hspace.1 \
789 d26d808a Iustin Pop
	man/htools.1
790 e8230860 Michael Hanselmann
791 5a19bd35 Iustin Pop
manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
792 6be8e2bf Iustin Pop
manhtml = $(patsubst %.rst,%.html,$(manrst))
793 fcdb582d Michael Hanselmann
mangen = $(patsubst %.rst,%.gen,$(manrst))
794 25c92bc5 Michael Hanselmann
maninput = \
795 5a19bd35 Iustin Pop
	$(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
796 de8eea3e Iustin Pop
	$(patsubst %.html,%.html.in,$(manhtml)) \
797 fcdb582d Michael Hanselmann
	man/footer.man man/footer.html $(mangen)
798 e8230860 Michael Hanselmann
799 e8230860 Michael Hanselmann
TEST_FILES = \
800 dad26941 Iustin Pop
	htest/data/common-suffix.data \
801 dad26941 Iustin Pop
	htest/data/hail-alloc-drbd.json \
802 dad26941 Iustin Pop
	htest/data/hail-change-group.json \
803 dad26941 Iustin Pop
	htest/data/hail-invalid-reloc.json \
804 dad26941 Iustin Pop
	htest/data/hail-node-evac.json \
805 dad26941 Iustin Pop
	htest/data/hail-reloc-drbd.json \
806 659d769d Dato Simó
	htest/data/hbal-excl-tags.data \
807 dad26941 Iustin Pop
	htest/data/hbal-split-insts.data \
808 dad26941 Iustin Pop
	htest/data/invalid-node.data \
809 dad26941 Iustin Pop
	htest/data/missing-resources.data \
810 dad26941 Iustin Pop
	htest/data/rapi/groups.json \
811 dad26941 Iustin Pop
	htest/data/rapi/info.json \
812 dad26941 Iustin Pop
	htest/data/rapi/instances.json \
813 dad26941 Iustin Pop
	htest/data/rapi/nodes.json \
814 dad26941 Iustin Pop
	htest/shelltests/htools-balancing.test \
815 dad26941 Iustin Pop
	htest/shelltests/htools-basic.test \
816 dad26941 Iustin Pop
	htest/shelltests/htools-dynutil.test \
817 dad26941 Iustin Pop
	htest/shelltests/htools-excl.test \
818 dad26941 Iustin Pop
	htest/shelltests/htools-hail.test \
819 dad26941 Iustin Pop
	htest/shelltests/htools-hspace.test \
820 dad26941 Iustin Pop
	htest/shelltests/htools-invalid.test \
821 dad26941 Iustin Pop
	htest/shelltests/htools-multi-group.test \
822 dad26941 Iustin Pop
	htest/shelltests/htools-no-backend.test \
823 dad26941 Iustin Pop
	htest/shelltests/htools-rapi.test \
824 dad26941 Iustin Pop
	htest/shelltests/htools-single-group.test \
825 dad26941 Iustin Pop
	htest/shelltests/htools-text-backend.test \
826 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.0.txt \
827 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.3.txt \
828 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-disk.txt \
829 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip4.txt \
830 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip6.txt \
831 27e46076 Michael Hanselmann
	test/data/cert1.pem \
832 d12b9f66 Michael Hanselmann
	test/data/cert2.pem \
833 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-dummy0.txt \
834 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv4.txt \
835 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv6.txt \
836 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv4.txt \
837 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv6.txt \
838 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline.txt \
839 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo.txt \
840 585c8187 Guido Trotter
	test/data/kvm_0.12.5_help.txt \
841 dad26941 Iustin Pop
	test/data/kvm_0.15.90_help.txt \
842 585c8187 Guido Trotter
	test/data/kvm_0.9.1_help.txt \
843 dad26941 Iustin Pop
	test/data/kvm_1.0_help.txt \
844 1e6fab60 Agata Murawska
	test/data/ovfdata/compr_disk.vmdk.gz \
845 d92518d3 Agata Murawska
	test/data/ovfdata/config.ini \
846 1e6fab60 Agata Murawska
	test/data/ovfdata/corrupted_resources.ovf \
847 d92518d3 Agata Murawska
	test/data/ovfdata/empty.ini \
848 1e6fab60 Agata Murawska
	test/data/ovfdata/empty.ovf \
849 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.mf \
850 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.ovf \
851 1e6fab60 Agata Murawska
	test/data/ovfdata/gzip_disk.ovf \
852 1e6fab60 Agata Murawska
	test/data/ovfdata/new_disk.vmdk \
853 d92518d3 Agata Murawska
	test/data/ovfdata/no_disk.ini \
854 1e6fab60 Agata Murawska
	test/data/ovfdata/no_disk_in_ref.ovf \
855 d92518d3 Agata Murawska
	test/data/ovfdata/no_os.ini \
856 1e6fab60 Agata Murawska
	test/data/ovfdata/no_ovf.ova \
857 dad26941 Iustin Pop
	test/data/ovfdata/other/rawdisk.raw \
858 1e6fab60 Agata Murawska
	test/data/ovfdata/ova.ova \
859 d92518d3 Agata Murawska
	test/data/ovfdata/rawdisk.raw \
860 dad26941 Iustin Pop
	test/data/ovfdata/second_disk.vmdk \
861 d92518d3 Agata Murawska
	test/data/ovfdata/unsafe_path.ini \
862 1e6fab60 Agata Murawska
	test/data/ovfdata/virtualbox.ovf \
863 d92518d3 Agata Murawska
	test/data/ovfdata/wrong_config.ini \
864 dad26941 Iustin Pop
	test/data/ovfdata/wrong_extension.ovd \
865 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.mf \
866 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.ovf \
867 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_ova.ova \
868 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_xml.ovf \
869 dad26941 Iustin Pop
	test/data/proc_drbd8.txt \
870 dad26941 Iustin Pop
	test/data/proc_drbd80-emptyline.txt \
871 dad26941 Iustin Pop
	test/data/proc_drbd83.txt \
872 dad26941 Iustin Pop
	test/data/proc_drbd83_sync.txt \
873 dad26941 Iustin Pop
	test/data/proc_drbd83_sync_krnl2.6.39.txt \
874 dad26941 Iustin Pop
	test/data/sys_drbd_usermode_helper.txt \
875 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.02.txt \
876 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-fail.txt \
877 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-ok.txt \
878 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.02.txt \
879 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.66.txt \
880 30f2802f Iustin Pop
	test/ganeti-cli.test \
881 dad26941 Iustin Pop
	test/gnt-cli.test \
882 dad26941 Iustin Pop
	test/import-export_unittest-helper
883 e8230860 Michael Hanselmann
884 e8c8cf1a Michael Hanselmann
python_tests = \
885 3ade0e0e Michael Hanselmann
	doc/examples/rapi_testutils.py \
886 dad26941 Iustin Pop
	test/cfgupgrade_unittest.py \
887 dad26941 Iustin Pop
	test/docs_unittest.py \
888 17496050 Guido Trotter
	test/ganeti.asyncnotifier_unittest.py \
889 f942a838 Michael Hanselmann
	test/ganeti.backend_unittest.py \
890 6de7c41d Iustin Pop
	test/ganeti.bdev_unittest.py \
891 6de7c41d Iustin Pop
	test/ganeti.cli_unittest.py \
892 66d1f035 René Nussbaumer
	test/ganeti.client.gnt_cluster_unittest.py \
893 25ce3ec4 Michael Hanselmann
	test/ganeti.client.gnt_instance_unittest.py \
894 e1c701e7 Michael Hanselmann
	test/ganeti.client.gnt_job_unittest.py \
895 6de7c41d Iustin Pop
	test/ganeti.cmdlib_unittest.py \
896 cea881e5 Michael Hanselmann
	test/ganeti.compat_unittest.py \
897 edf7d66e Iustin Pop
	test/ganeti.confd.client_unittest.py \
898 e8230860 Michael Hanselmann
	test/ganeti.config_unittest.py \
899 6de7c41d Iustin Pop
	test/ganeti.constants_unittest.py \
900 dad26941 Iustin Pop
	test/ganeti.daemon_unittest.py \
901 3bd19c66 Michael Hanselmann
	test/ganeti.errors_unittest.py \
902 e8230860 Michael Hanselmann
	test/ganeti.hooks_unittest.py \
903 ecdf0398 Michael Hanselmann
	test/ganeti.ht_unittest.py \
904 6de7c41d Iustin Pop
	test/ganeti.http_unittest.py \
905 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_chroot_unittest.py \
906 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_fake_unittest.py \
907 748e4b5a Michael Hanselmann
	test/ganeti.hypervisor.hv_kvm_unittest.py \
908 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_lxc_unittest.py \
909 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_xen_unittest.py \
910 dad26941 Iustin Pop
	test/ganeti.hypervisor_unittest.py \
911 bb44b1ae Michael Hanselmann
	test/ganeti.impexpd_unittest.py \
912 989a8bee Michael Hanselmann
	test/ganeti.jqueue_unittest.py \
913 6f1aa78d Michael Hanselmann
	test/ganeti.jstore_unittest.py \
914 e8230860 Michael Hanselmann
	test/ganeti.locking_unittest.py \
915 231db3a5 Michael Hanselmann
	test/ganeti.luxi_unittest.py \
916 33b4fa9f René Nussbaumer
	test/ganeti.masterd.iallocator_unittest.py \
917 033a1d00 Michael Hanselmann
	test/ganeti.masterd.instance_unittest.py \
918 407339d0 Michael Hanselmann
	test/ganeti.mcpu_unittest.py \
919 a744b676 Manuel Franceschini
	test/ganeti.netutils_unittest.py \
920 4c14965f Guido Trotter
	test/ganeti.objects_unittest.py \
921 32683096 René Nussbaumer
	test/ganeti.objectutils_unittest.py \
922 c32b908e Michael Hanselmann
	test/ganeti.opcodes_unittest.py \
923 1e6fab60 Agata Murawska
	test/ganeti.ovf_unittest.py \
924 a123dc19 Michael Hanselmann
	test/ganeti.qlang_unittest.py \
925 4ca96421 Michael Hanselmann
	test/ganeti.query_unittest.py \
926 cfaeaaf7 Michael Hanselmann
	test/ganeti.rapi.baserlib_unittest.py \
927 95ab4de9 David Knowles
	test/ganeti.rapi.client_unittest.py \
928 4cbd4462 Oleksiy Mishchenko
	test/ganeti.rapi.resources_unittest.py \
929 6395cebb Michael Hanselmann
	test/ganeti.rapi.rlib2_unittest.py \
930 a85f23fa Michael Hanselmann
	test/ganeti.rapi.testutils_unittest.py \
931 33231500 Michael Hanselmann
	test/ganeti.rpc_unittest.py \
932 f12e1736 René Nussbaumer
	test/ganeti.runtime_unittest.py \
933 6de7c41d Iustin Pop
	test/ganeti.serializer_unittest.py \
934 6de7c41d Iustin Pop
	test/ganeti.ssh_unittest.py \
935 048eeb2b Iustin Pop
	test/ganeti.storage_unittest.py \
936 0d2bf835 René Nussbaumer
	test/ganeti.tools.ensure_dirs_unittest.py \
937 d12b9f66 Michael Hanselmann
	test/ganeti.tools.prepare_node_join_unittest.py \
938 93be53da Balazs Lecz
	test/ganeti.uidpool_unittest.py \
939 4fd029cf Michael Hanselmann
	test/ganeti.utils.algo_unittest.py \
940 9d1b963f Michael Hanselmann
	test/ganeti.utils.filelock_unittest.py \
941 f21bb4b7 Michael Hanselmann
	test/ganeti.utils.hash_unittest.py \
942 7ebadeb3 Bernardo Dal Seno
	test/ganeti.utils.io_unittest-runasroot.py \
943 dad26941 Iustin Pop
	test/ganeti.utils.io_unittest.py \
944 b6fa9a44 Michael Hanselmann
	test/ganeti.utils.log_unittest.py \
945 8dc76d54 Guido Trotter
	test/ganeti.utils.mlock_unittest.py \
946 17b97ab3 Michael Hanselmann
	test/ganeti.utils.nodesetup_unittest.py \
947 a4ccecf6 Michael Hanselmann
	test/ganeti.utils.process_unittest.py \
948 79d22269 Michael Hanselmann
	test/ganeti.utils.retry_unittest.py \
949 7fcffe27 Michael Hanselmann
	test/ganeti.utils.text_unittest.py \
950 7831fc5f Michael Hanselmann
	test/ganeti.utils.wrapper_unittest.py \
951 c50645c0 Michael Hanselmann
	test/ganeti.utils.x509_unittest.py \
952 4fd029cf Michael Hanselmann
	test/ganeti.utils_unittest.py \
953 05e733b4 Michael Hanselmann
	test/ganeti.vcluster_unittest.py \
954 3f991867 Michael Hanselmann
	test/ganeti.workerpool_unittest.py \
955 4fd2660d Michael Hanselmann
	test/pycurl_reset_unittest.py \
956 dad26941 Iustin Pop
	test/qa.qa_config_unittest.py \
957 055f822b Michael Hanselmann
	test/tempfile_fork_unittest.py
958 e8230860 Michael Hanselmann
959 f0f3a6df Iustin Pop
haskell_tests = htest/test
960 b91e9518 Iustin Pop
961 e8c8cf1a Michael Hanselmann
dist_TESTS = \
962 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
963 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
964 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
965 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
966 30f2802f Iustin Pop
	test/cli-test.bash \
967 92886204 Michael Hanselmann
	test/bash_completion.bash \
968 e8c8cf1a Michael Hanselmann
	$(python_tests)
969 e8c8cf1a Michael Hanselmann
970 e8230860 Michael Hanselmann
nodist_TESTS =
971 d3cd5a3f Iustin Pop
check_SCRIPTS =
972 d3cd5a3f Iustin Pop
973 e5f6768c Iustin Pop
if WANT_HTOOLSTESTS
974 b91e9518 Iustin Pop
nodist_TESTS += $(haskell_tests)
975 f0f3a6df Iustin Pop
dist_TESTS += htest/offline-test.sh
976 f0f3a6df Iustin Pop
check_SCRIPTS += htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
977 b91e9518 Iustin Pop
endif
978 e8230860 Michael Hanselmann
979 e8230860 Michael Hanselmann
TESTS = $(dist_TESTS) $(nodist_TESTS)
980 e8230860 Michael Hanselmann
981 27e336af Michael Hanselmann
# Environment for all tests
982 27e336af Michael Hanselmann
PLAIN_TESTS_ENVIRONMENT = \
983 30f2802f Iustin Pop
	PYTHONPATH=. \
984 30f2802f Iustin Pop
	TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
985 30f2802f Iustin Pop
	PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
986 30f2802f Iustin Pop
	$(RUN_IN_TEMPDIR)
987 27e336af Michael Hanselmann
988 27e336af Michael Hanselmann
# Environment for tests run by automake
989 f848ac00 Michael Hanselmann
TESTS_ENVIRONMENT = \
990 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
991 6e06b36c Iustin Pop
992 eed5c5df Michael Hanselmann
all_python_code = \
993 01a3a718 Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
994 cc120286 Bernardo Dal Seno
	$(python_scripts) \
995 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
996 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts) \
997 e8c8cf1a Michael Hanselmann
	$(python_tests) \
998 01a3a718 Michael Hanselmann
	$(pkgpython_PYTHON) \
999 2d48a3a2 Michael Hanselmann
	$(client_PYTHON) \
1000 01a3a718 Michael Hanselmann
	$(hypervisor_PYTHON) \
1001 01a3a718 Michael Hanselmann
	$(rapi_PYTHON) \
1002 899c4d2c Michael Hanselmann
	$(server_PYTHON) \
1003 0d2bf835 René Nussbaumer
	$(pytools_PYTHON) \
1004 01a3a718 Michael Hanselmann
	$(http_PYTHON) \
1005 01a3a718 Michael Hanselmann
	$(confd_PYTHON) \
1006 dc101ecc Michael Hanselmann
	$(masterd_PYTHON) \
1007 bb44b1ae Michael Hanselmann
	$(impexpd_PYTHON) \
1008 c047a981 Michael Hanselmann
	$(utils_PYTHON) \
1009 9f4bb951 Michael Hanselmann
	$(watcher_PYTHON) \
1010 a8c68e44 Michael Hanselmann
	$(noinst_PYTHON) \
1011 a8c68e44 Michael Hanselmann
	$(qa_scripts)
1012 01a3a718 Michael Hanselmann
1013 eed5c5df Michael Hanselmann
srclink_files = \
1014 6be8e2bf Iustin Pop
	man/footer.rst \
1015 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
1016 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
1017 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
1018 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
1019 30f2802f Iustin Pop
	test/cli-test.bash \
1020 92886204 Michael Hanselmann
	test/bash_completion.bash \
1021 f0f3a6df Iustin Pop
	htest/offline-test.sh \
1022 f0f3a6df Iustin Pop
	htest/cli-tests-defs.sh \
1023 d6159933 Iustin Pop
	$(all_python_code) \
1024 51309138 Iustin Pop
	$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
1025 eed5c5df Michael Hanselmann
1026 eed5c5df Michael Hanselmann
check_python_code = \
1027 e4e7c7df Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
1028 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
1029 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
1030 95eb4188 Michael Hanselmann
	$(DOCPP) \
1031 eed5c5df Michael Hanselmann
	$(all_python_code)
1032 eed5c5df Michael Hanselmann
1033 e4e7c7df Michael Hanselmann
lint_python_code = \
1034 f60d352e Michael Hanselmann
	ganeti \
1035 f1763373 Iustin Pop
	ganeti/http/server.py \
1036 f60d352e Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
1037 cc120286 Bernardo Dal Seno
	$(python_scripts) \
1038 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
1039 2cc8bdd0 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
1040 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
1041 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
1042 95eb4188 Michael Hanselmann
	$(DOCPP) \
1043 2cc8bdd0 Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
1044 eed5c5df Michael Hanselmann
1045 f6cbcc06 Michael Hanselmann
standalone_python_modules = \
1046 f6cbcc06 Michael Hanselmann
	lib/rapi/client.py \
1047 f6cbcc06 Michael Hanselmann
	tools/ganeti-listrunner
1048 f6cbcc06 Michael Hanselmann
1049 21bf2e2e Andrea Spadaccini
pep8_python_code = \
1050 21bf2e2e Andrea Spadaccini
	ganeti \
1051 21bf2e2e Andrea Spadaccini
	ganeti/http/server.py \
1052 21bf2e2e Andrea Spadaccini
	$(dist_sbin_SCRIPTS) \
1053 cc120286 Bernardo Dal Seno
	$(python_scripts) \
1054 21bf2e2e Andrea Spadaccini
	$(pkglib_python_scripts) \
1055 21bf2e2e Andrea Spadaccini
	$(BUILD_BASH_COMPLETION) \
1056 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
1057 21bf2e2e Andrea Spadaccini
	$(DOCPP) \
1058 21bf2e2e Andrea Spadaccini
	$(PYTHON_BOOTSTRAP) \
1059 21bf2e2e Andrea Spadaccini
	qa
1060 21bf2e2e Andrea Spadaccini
1061 571b34f8 Michael Hanselmann
test/daemon-util_unittest.bash: daemons/daemon-util
1062 571b34f8 Michael Hanselmann
1063 46118ed2 Iustin Pop
test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1064 7172f605 Michael Hanselmann
1065 92886204 Michael Hanselmann
test/bash_completion.bash: doc/examples/bash_completion-debug
1066 92886204 Michael Hanselmann
1067 26916aad Apollon Oikonomopoulos
tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1068 26916aad Apollon Oikonomopoulos
	sed -f $(REPLACE_VARS_SED) < $< > $@
1069 26916aad Apollon Oikonomopoulos
	chmod +x $@
1070 26916aad Apollon Oikonomopoulos
1071 29386d3e Michael Hanselmann
tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1072 29386d3e Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1073 29386d3e Michael Hanselmann
	chmod +x $@
1074 29386d3e Michael Hanselmann
1075 490bec02 Iustin Pop
daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1076 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1077 5c566e17 Michael Hanselmann
	chmod +x $@
1078 e8230860 Michael Hanselmann
1079 490bec02 Iustin Pop
doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1080 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1081 e8230860 Michael Hanselmann
1082 e80aeb89 Michael Hanselmann
doc/examples/bash_completion: BC_ARGS = --compact
1083 e80aeb89 Michael Hanselmann
doc/examples/bash_completion-debug: BC_ARGS =
1084 e80aeb89 Michael Hanselmann
1085 e80aeb89 Michael Hanselmann
doc/examples/bash_completion doc/examples/bash_completion-debug: \
1086 e80aeb89 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1087 4c3d5fb6 Iustin Pop
	lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1088 46118ed2 Iustin Pop
	daemons/ganeti-cleaner \
1089 ada0e680 Iustin Pop
	$(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
1090 e80aeb89 Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1091 e80aeb89 Michael Hanselmann
	  $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1092 4f3d5b76 Michael Hanselmann
1093 f86e82ef Iustin Pop
doc/%.png: doc/%.dot
1094 2ab2b9f5 Iustin Pop
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1095 f86e82ef Iustin Pop
	$(DOT) -Tpng -o $@ $<
1096 f86e82ef Iustin Pop
1097 de8eea3e Iustin Pop
man/footer.man: man/footer.rst
1098 de8eea3e Iustin Pop
	@test -n "$(PANDOC)" || \
1099 de8eea3e Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1100 de8eea3e Iustin Pop
	$(PANDOC) -f rst -t man -o $@ $<
1101 de8eea3e Iustin Pop
1102 6be8e2bf Iustin Pop
man/footer.html: man/footer.rst
1103 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1104 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1105 6be8e2bf Iustin Pop
	$(PANDOC) -f rst -t html -o $@ $<
1106 6be8e2bf Iustin Pop
1107 7142485a Iustin Pop
man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1108 d7772efa Iustin Pop
	lib/build/shell_example_lexer.py \
1109 a13d6911 Iustin Pop
	| $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1110 387863a5 Iustin Pop
	@echo "Checking $< for hardcoded paths..."
1111 387863a5 Iustin Pop
	@if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1112 387863a5 Iustin Pop
	  echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1113 387863a5 Iustin Pop
	  exit 1; \
1114 387863a5 Iustin Pop
	fi
1115 a13d6911 Iustin Pop
	set -e ; \
1116 a13d6911 Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
1117 a13d6911 Iustin Pop
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1118 a13d6911 Iustin Pop
	trap - EXIT
1119 fcdb582d Michael Hanselmann
1120 5a19bd35 Iustin Pop
man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1121 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1122 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1123 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1124 9c45babb Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
1125 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1126 9c45babb Iustin Pop
	  sed -e 's/\\@/@/g' > $@; \
1127 73d0e218 Iustin Pop
	if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1128 c55cc346 Iustin Pop
	$(CHECK_MAN_DASHES) $@; \
1129 9c45babb Iustin Pop
	trap - EXIT
1130 9c45babb Iustin Pop
1131 2ab2b9f5 Iustin Pop
1132 fcdb582d Michael Hanselmann
man/%.html.in: man/%.gen man/footer.html
1133 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1134 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1135 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1136 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1137 6be8e2bf Iustin Pop
	  sed -e 's/\\@/@/g' > $@
1138 6be8e2bf Iustin Pop
1139 55398706 Iustin Pop
man/%: man/%.in  $(REPLACE_VARS_SED)
1140 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1141 f29266b4 Iustin Pop
1142 fc1282b8 Iustin Pop
epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1143 fc1282b8 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1144 f774bd03 Michael Hanselmann
1145 84a12e40 Iustin Pop
vcs-version:
1146 84a12e40 Iustin Pop
	if test -d .git; then \
1147 84a12e40 Iustin Pop
	  git describe > $@; \
1148 84a12e40 Iustin Pop
	elif test ! -f $@ ; then \
1149 84a12e40 Iustin Pop
	  echo "Cannot auto-generate $@ file"; exit 1; \
1150 84a12e40 Iustin Pop
	fi
1151 84a12e40 Iustin Pop
1152 316dc1ff Iustin Pop
.PHONY: clean-vcs-version
1153 316dc1ff Iustin Pop
clean-vcs-version:
1154 316dc1ff Iustin Pop
	rm -f vcs-version
1155 316dc1ff Iustin Pop
1156 84a12e40 Iustin Pop
.PHONY: regen-vcs-version
1157 84a12e40 Iustin Pop
regen-vcs-version:
1158 e8230860 Michael Hanselmann
	set -e; \
1159 84a12e40 Iustin Pop
	cd $(srcdir); \
1160 84a12e40 Iustin Pop
	if test -d .git; then \
1161 b0b8458a Iustin Pop
	  $(MAKE) $(AM_MAKEFLAGS) clean-vcs-version; \
1162 b0b8458a Iustin Pop
	  $(MAKE) $(AM_MAKEFLAGS) vcs-version; \
1163 84a12e40 Iustin Pop
	fi
1164 84a12e40 Iustin Pop
1165 2997cb0a Iustin Pop
htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1166 4c3d5fb6 Iustin Pop
	vcs-version $(built_base_sources)
1167 d6159933 Iustin Pop
	set -e; \
1168 d6159933 Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1169 d6159933 Iustin Pop
	sed -e "s/%ver%/$$VCSVER/" < $< > $@
1170 d6159933 Iustin Pop
1171 d99d1e36 Iustin Pop
htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1172 f11e524b Iustin Pop
	lib/constants.py lib/_autoconf.py lib/luxi.py \
1173 4c3d5fb6 Iustin Pop
	$(CONVERT_CONSTANTS) $(built_base_sources) \
1174 ef958f2a Iustin Pop
	| lib/_vcsversion.py
1175 11fd5a86 Iustin Pop
	set -e; \
1176 876f6a5e Iustin Pop
	{ cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1177 d99d1e36 Iustin Pop
1178 b88fcdd0 Iustin Pop
htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1179 b88fcdd0 Iustin Pop
	$(built_base_sources)
1180 b88fcdd0 Iustin Pop
	set -e; \
1181 b88fcdd0 Iustin Pop
	{ cat $< ; \
1182 b88fcdd0 Iustin Pop
	  echo ; \
1183 b88fcdd0 Iustin Pop
	  for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1184 b88fcdd0 Iustin Pop
	    echo "import $$name ()" ; \
1185 b88fcdd0 Iustin Pop
	  done ; \
1186 b88fcdd0 Iustin Pop
	} > $@
1187 b88fcdd0 Iustin Pop
1188 3735787e Iustin Pop
lib/_autoconf.py: Makefile | stamp-directories
1189 84a12e40 Iustin Pop
	set -e; \
1190 e8230860 Michael Hanselmann
	{ echo '# This file is automatically generated, do not edit!'; \
1191 e8230860 Michael Hanselmann
	  echo '#'; \
1192 67047322 Iustin Pop
	  echo ''; \
1193 67047322 Iustin Pop
	  echo '"""Build-time configuration for Ganeti.'; \
1194 67047322 Iustin Pop
	  echo '';\
1195 67047322 Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1196 67047322 Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1197 67047322 Iustin Pop
	  echo 'not edit by hand).'; \
1198 67047322 Iustin Pop
	  echo ''; \
1199 67047322 Iustin Pop
	  echo '"""'; \
1200 67047322 Iustin Pop
	  echo ''; \
1201 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1202 0a4e7f24 Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1203 0a4e7f24 Iustin Pop
	  echo '# style warnings' ; \
1204 0a4e7f24 Iustin Pop
	  echo ''; \
1205 e8230860 Michael Hanselmann
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1206 e8230860 Michael Hanselmann
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1207 e8230860 Michael Hanselmann
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1208 e8230860 Michael Hanselmann
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1209 e8230860 Michael Hanselmann
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1210 e8230860 Michael Hanselmann
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1211 e8230860 Michael Hanselmann
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1212 e8230860 Michael Hanselmann
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
1213 553bd93f Vitaly Kuznetsov
	  echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1214 052783ff Michael Hanselmann
	  echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1215 052783ff Michael Hanselmann
	  echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1216 e8230860 Michael Hanselmann
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1217 e8230860 Michael Hanselmann
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1218 2f2dbb4b Jun Futagawa
	  echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1219 e8230860 Michael Hanselmann
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1220 e8230860 Michael Hanselmann
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1221 b8203e1e Iustin Pop
	  echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1222 e8230860 Michael Hanselmann
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1223 cb7c0198 Iustin Pop
	  echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1224 4b97f902 Apollon Oikonomopoulos
	  echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1225 4b97f902 Apollon Oikonomopoulos
	  echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1226 e8230860 Michael Hanselmann
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1227 7e2c5b9e Guido Trotter
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
1228 c4dfb0b6 Andrea Spadaccini
	  echo "IP_PATH = '$(IP_PATH)'"; \
1229 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_PATH = '$(SOCAT)'"; \
1230 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1231 e90739d6 Michael Hanselmann
	  echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1232 bea60381 Michael Hanselmann
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1233 bea60381 Michael Hanselmann
	  echo "TOOLSDIR = '$(toolsdir)'"; \
1234 4f3d5b76 Michael Hanselmann
	  echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1235 ada0e680 Iustin Pop
	  echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1236 f154a7a3 Michael Hanselmann
	  echo "PKGLIBDIR = '$(pkglibdir)'"; \
1237 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1238 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1239 551b6283 Iustin Pop
	  echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1240 8b72b05c René Nussbaumer
	  echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1241 f12e1736 René Nussbaumer
	  echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1242 8b72b05c René Nussbaumer
	  echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1243 f12e1736 René Nussbaumer
	  echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1244 8b72b05c René Nussbaumer
	  echo "RAPI_USER = '$(RAPI_USER)'"; \
1245 f12e1736 René Nussbaumer
	  echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1246 f12e1736 René Nussbaumer
	  echo "CONFD_USER = '$(CONFD_USER)'"; \
1247 f12e1736 René Nussbaumer
	  echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1248 f12e1736 René Nussbaumer
	  echo "NODED_USER = '$(NODED_USER)'"; \
1249 03881cb0 René Nussbaumer
	  echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1250 3536c792 Iustin Pop
	  echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1251 a002ed79 Agata Murawska
	  echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1252 21a5e56c Iustin Pop
	  echo "HTOOLS = True"; \
1253 cd8b0072 Iustin Pop
	  echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1254 1eb37421 René Nussbaumer
	  echo "XEN_CMD = '$(XEN_CMD)'"; \
1255 42ab9ac4 Iustin Pop
	  echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1256 e8230860 Michael Hanselmann
	} > $@
1257 e8230860 Michael Hanselmann
1258 3735787e Iustin Pop
lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1259 13aeae6a Iustin Pop
	set -e; \
1260 13aeae6a Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1261 13aeae6a Iustin Pop
	{ echo '# This file is automatically generated, do not edit!'; \
1262 13aeae6a Iustin Pop
	  echo '#'; \
1263 13aeae6a Iustin Pop
	  echo ''; \
1264 13aeae6a Iustin Pop
	  echo '"""Build-time VCS version number for Ganeti.'; \
1265 13aeae6a Iustin Pop
	  echo '';\
1266 13aeae6a Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1267 13aeae6a Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1268 13aeae6a Iustin Pop
	  echo 'not edit by hand).'; \
1269 13aeae6a Iustin Pop
	  echo ''; \
1270 13aeae6a Iustin Pop
	  echo '"""'; \
1271 13aeae6a Iustin Pop
	  echo ''; \
1272 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1273 13aeae6a Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1274 13aeae6a Iustin Pop
	  echo '# style warnings' ; \
1275 13aeae6a Iustin Pop
	  echo ''; \
1276 13aeae6a Iustin Pop
	  echo "VCS_VERSION = '$$VCSVER'"; \
1277 13aeae6a Iustin Pop
	} > $@
1278 13aeae6a Iustin Pop
1279 96a7481d Michael Hanselmann
lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1280 96a7481d Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1281 d5a2a550 Michael Hanselmann
1282 6e3bf290 Michael Hanselmann
$(SHELL_ENV_INIT): Makefile stamp-directories
1283 6e3bf290 Michael Hanselmann
	set -e; \
1284 6e3bf290 Michael Hanselmann
	{ echo '# Allow overriding for tests'; \
1285 6e3bf290 Michael Hanselmann
	  echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1286 6e3bf290 Michael Hanselmann
	  echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1287 6e3bf290 Michael Hanselmann
	  echo; \
1288 6e3bf290 Michael Hanselmann
	  echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1289 6e3bf290 Michael Hanselmann
	  echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1290 6e3bf290 Michael Hanselmann
	  echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1291 6e3bf290 Michael Hanselmann
	  echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1292 6e3bf290 Michael Hanselmann
	  echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1293 6e3bf290 Michael Hanselmann
	} > $@
1294 6e3bf290 Michael Hanselmann
1295 6e3bf290 Michael Hanselmann
$(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1296 e8230860 Michael Hanselmann
	set -e; \
1297 e8230860 Michael Hanselmann
	{ echo 's#@PREFIX@#$(prefix)#g'; \
1298 e8230860 Michael Hanselmann
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1299 e8230860 Michael Hanselmann
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1300 7a2ba406 Luca Bigliardi
	  echo 's#@BINDIR@#$(bindir)#g'; \
1301 e8230860 Michael Hanselmann
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
1302 335ba60d Guido Trotter
	  echo 's#@LIBDIR@#$(libdir)#g'; \
1303 e8230860 Michael Hanselmann
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1304 2f2dbb4b Jun Futagawa
	  echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1305 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1306 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1307 56956bcb Iustin Pop
	  echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1308 56956bcb Iustin Pop
	  echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1309 d3b4cf9f Iustin Pop
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1310 7e1fac25 Michael Hanselmann
	  echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1311 c5159571 Iustin Pop
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1312 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1313 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1314 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1315 0d150c50 René Nussbaumer
	  echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1316 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1317 0d150c50 René Nussbaumer
	  echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1318 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1319 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1320 46a8da3b René Nussbaumer
	  echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1321 cd8b0072 Iustin Pop
	  echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1322 fc1282b8 Iustin Pop
	  echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1323 42ab9ac4 Iustin Pop
	  echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1324 6e3bf290 Michael Hanselmann
	  echo; \
1325 6e3bf290 Michael Hanselmann
	  echo '/^@SHELL_ENV_INIT@$$/ {'; \
1326 6e3bf290 Michael Hanselmann
	  echo '  r $(SHELL_ENV_INIT)'; \
1327 6e3bf290 Michael Hanselmann
	  echo '  d'; \
1328 6e3bf290 Michael Hanselmann
	  echo '}'; \
1329 e8230860 Michael Hanselmann
	} > $@
1330 e8230860 Michael Hanselmann
1331 67313146 Michael Hanselmann
# Using deferred evaluation
1332 899c4d2c Michael Hanselmann
daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1333 9f4bb951 Michael Hanselmann
daemons/ganeti-watcher: MODULE = ganeti.watcher
1334 67313146 Michael Hanselmann
scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1335 0d2bf835 René Nussbaumer
tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1336 d12b9f66 Michael Hanselmann
tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1337 189b51fa Iustin Pop
$(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1338 67313146 Michael Hanselmann
1339 3735787e Iustin Pop
$(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1340 67313146 Michael Hanselmann
	test -n "$(MODULE)" || { echo Missing module; exit 1; }
1341 2d48a3a2 Michael Hanselmann
	set -e; \
1342 d75e738e Michael Hanselmann
	{ echo '#!/usr/bin/python'; \
1343 2d48a3a2 Michael Hanselmann
	  echo '# This file is automatically generated, do not edit!'; \
1344 67313146 Michael Hanselmann
	  echo "# Edit $(MODULE) instead."; \
1345 2d48a3a2 Michael Hanselmann
	  echo; \
1346 67313146 Michael Hanselmann
	  echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1347 2d48a3a2 Michael Hanselmann
	  echo; \
1348 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0103'; \
1349 2d48a3a2 Michael Hanselmann
	  echo '# C0103: Invalid name'; \
1350 2d48a3a2 Michael Hanselmann
	  echo; \
1351 2d48a3a2 Michael Hanselmann
	  echo 'import sys'; \
1352 67313146 Michael Hanselmann
	  echo 'import $(MODULE) as main'; \
1353 2d48a3a2 Michael Hanselmann
	  echo; \
1354 2d48a3a2 Michael Hanselmann
	  echo '# Temporarily alias commands until bash completion'; \
1355 2d48a3a2 Michael Hanselmann
	  echo '# generator is changed'; \
1356 67313146 Michael Hanselmann
	  echo 'if hasattr(main, "commands"):'; \
1357 55766d34 Andrea Spadaccini
	  echo '  commands = main.commands # pylint: disable=E1101'; \
1358 3f42b4f6 Michael Hanselmann
	  echo 'if hasattr(main, "aliases"):'; \
1359 55766d34 Andrea Spadaccini
	  echo '  aliases = main.aliases # pylint: disable=E1101'; \
1360 2d48a3a2 Michael Hanselmann
	  echo; \
1361 2d48a3a2 Michael Hanselmann
	  echo 'if __name__ == "__main__":'; \
1362 67313146 Michael Hanselmann
	  echo '  sys.exit(main.Main())'; \
1363 2d48a3a2 Michael Hanselmann
	} > $@
1364 2d48a3a2 Michael Hanselmann
	chmod u+x $@
1365 2d48a3a2 Michael Hanselmann
1366 3096524e Iustin Pop
$(HS_BUILT_TEST_HELPERS): Makefile
1367 3096524e Iustin Pop
	@test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1368 3096524e Iustin Pop
	set -e; \
1369 3096524e Iustin Pop
	{ echo '#!/bin/sh'; \
1370 3096524e Iustin Pop
	  echo '# This file is automatically generated, do not edit!'; \
1371 3096524e Iustin Pop
	  echo "# Edit Makefile.am instead."; \
1372 3096524e Iustin Pop
	  echo; \
1373 f0f3a6df Iustin Pop
	  echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1374 3096524e Iustin Pop
	} > $@
1375 3096524e Iustin Pop
	chmod u+x $@
1376 3096524e Iustin Pop
1377 3735787e Iustin Pop
stamp-directories: Makefile
1378 924ecd85 Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) ganeti
1379 3735787e Iustin Pop
	@mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1380 3735787e Iustin Pop
	touch $@
1381 3735787e Iustin Pop
1382 e8230860 Michael Hanselmann
# We need to create symlinks because "make distcheck" will not install Python
1383 e8230860 Michael Hanselmann
# files when building.
1384 3735787e Iustin Pop
stamp-srclinks: Makefile | stamp-directories
1385 e8230860 Michael Hanselmann
	set -e; \
1386 01a3a718 Michael Hanselmann
	for i in $(srclink_files); do \
1387 e8230860 Michael Hanselmann
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1388 e8230860 Michael Hanselmann
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
1389 e8230860 Michael Hanselmann
		fi; \
1390 e8230860 Michael Hanselmann
	done
1391 dd1dfd9a Michael Hanselmann
	touch $@
1392 97a37b3f Michael Hanselmann
1393 9ff7e35c Michael Hanselmann
.PHONY: ganeti
1394 9ff7e35c Michael Hanselmann
ganeti:
1395 01f3e7b1 Iustin Pop
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1396 9ff7e35c Michael Hanselmann
1397 6b997854 Michael Hanselmann
.PHONY: check-dirs
1398 4c3d5fb6 Iustin Pop
check-dirs: $(GENERATED_FILES)
1399 0c1103d6 Iustin Pop
	@set -e; \
1400 6b997854 Michael Hanselmann
	find . -type d \( \( -name . \) -o \( \
1401 6b997854 Michael Hanselmann
		-name .git -o \
1402 6b997854 Michael Hanselmann
		-name autom4te.cache \
1403 6b997854 Michael Hanselmann
		\) -prune -o -print \) | { \
1404 6b997854 Michael Hanselmann
		error=; \
1405 6b997854 Michael Hanselmann
		while read dir; do \
1406 6b997854 Michael Hanselmann
			case "$$dir" in \
1407 6b997854 Michael Hanselmann
				$(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1408 6b997854 Michael Hanselmann
				*) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1409 6b997854 Michael Hanselmann
			esac; \
1410 6b997854 Michael Hanselmann
		done; \
1411 6b997854 Michael Hanselmann
		for dir in $(DIRS); do \
1412 6b997854 Michael Hanselmann
			if ! test -d "$$dir"; then \
1413 6b997854 Michael Hanselmann
				echo "Directory $$dir listed in DIRS does not exist" >&2; \
1414 6b997854 Michael Hanselmann
				error=1; \
1415 6b997854 Michael Hanselmann
			fi \
1416 6b997854 Michael Hanselmann
		done; \
1417 6b997854 Michael Hanselmann
		if test -n "$$error"; then exit 1; else exit 0; fi; \
1418 6b997854 Michael Hanselmann
	}
1419 6b997854 Michael Hanselmann
1420 f6cbcc06 Michael Hanselmann
.PHONY: check-local
1421 4c3d5fb6 Iustin Pop
check-local: check-dirs $(GENERATED_FILES)
1422 eed5c5df Michael Hanselmann
	$(CHECK_PYTHON_CODE) $(check_python_code)
1423 5d3c30df Michael Hanselmann
	PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1424 35576615 Michael Hanselmann
	$(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1425 7385c51d Michael Hanselmann
	$(CHECK_NEWS) < $(top_srcdir)/NEWS
1426 83ea5145 Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1427 dad26941 Iustin Pop
	@expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1428 154d7ba5 Michael Hanselmann
	if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1429 9488fd1d Michael Hanselmann
		echo "Incorrect version in README, expected $$expver"; \
1430 9488fd1d Michael Hanselmann
		exit 1; \
1431 7ecb3d0e Michael Hanselmann
	fi; \
1432 04c998a5 Michael Hanselmann
	for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1433 04c998a5 Michael Hanselmann
			doc/security.rst; do \
1434 d5114fa1 Michael Hanselmann
		if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1435 9822b1dd Iustin Pop
			"Documents Ganeti version $$expver"; then \
1436 d5114fa1 Michael Hanselmann
			echo "Incorrect version in $$file, expected $$expver"; \
1437 d5114fa1 Michael Hanselmann
			exit 1; \
1438 d5114fa1 Michael Hanselmann
		fi; \
1439 7a962ecc Michael Hanselmann
	done; \
1440 fc07a14e Michael Hanselmann
	if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1441 fc07a14e Michael Hanselmann
		echo "File $(top_srcdir)/doc/design-$$expver.rst not found"; \
1442 7a962ecc Michael Hanselmann
		exit 1; \
1443 7a962ecc Michael Hanselmann
	fi
1444 eed5c5df Michael Hanselmann
1445 49e11c49 Iustin Pop
.PHONY: hs-check
1446 f0f3a6df Iustin Pop
hs-check: htest/test htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
1447 49e11c49 Iustin Pop
	@rm -f test.tix
1448 f0f3a6df Iustin Pop
	./htest/test
1449 f0f3a6df Iustin Pop
	HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1450 49e11c49 Iustin Pop
1451 08366664 Michael Hanselmann
# E111: indentation is not a multiple of four
1452 5ae4945a Iustin Pop
# E121: continuation line indentation is not a multiple of four
1453 5ae4945a Iustin Pop
#       (since our indent level is not 4)
1454 5ae4945a Iustin Pop
# E125: continuation line does not distinguish itself from next logical line
1455 5ae4945a Iustin Pop
#       (since our indent level is not 4)
1456 5ae4945a Iustin Pop
# E127: continuation line over-indented for visual indent
1457 5ae4945a Iustin Pop
#       (since our indent level is not 4)
1458 5ae4945a Iustin Pop
# note: do NOT add E128 here; it's a valid style error in most cases!
1459 5ae4945a Iustin Pop
# I've seen real errors, but also some cases were we indent wrongly
1460 5ae4945a Iustin Pop
# due to line length; try to rework the cases where it is triggered,
1461 5ae4945a Iustin Pop
# instead of silencing it
1462 08366664 Michael Hanselmann
# E261: at least two spaces before inline comment
1463 08366664 Michael Hanselmann
# E501: line too long (80 characters)
1464 5ae4945a Iustin Pop
PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1465 08366664 Michael Hanselmann
1466 08366664 Michael Hanselmann
# For excluding pep8 expects filenames only, not whole paths
1467 08366664 Michael Hanselmann
PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1468 08366664 Michael Hanselmann
1469 6e4c8f68 Iustin Pop
LINT_TARGETS = pylint pylint-qa
1470 6e4c8f68 Iustin Pop
if HAS_PEP8
1471 6e4c8f68 Iustin Pop
LINT_TARGETS += pep8
1472 6e4c8f68 Iustin Pop
endif
1473 6e4c8f68 Iustin Pop
if HAS_HLINT
1474 6e4c8f68 Iustin Pop
LINT_TARGETS += hlint
1475 6e4c8f68 Iustin Pop
endif
1476 6e4c8f68 Iustin Pop
1477 e0098923 Iustin Pop
.PHONY: lint
1478 6e4c8f68 Iustin Pop
lint: $(LINT_TARGETS)
1479 6e4c8f68 Iustin Pop
1480 6e4c8f68 Iustin Pop
.PHONY: pylint
1481 4c3d5fb6 Iustin Pop
pylint: $(GENERATED_FILES)
1482 6d7cc5ff Michael Hanselmann
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1483 6d7cc5ff Michael Hanselmann
	$(PYLINT) $(LINT_OPTS) $(lint_python_code)
1484 6e4c8f68 Iustin Pop
1485 6e4c8f68 Iustin Pop
.PHONY: pylint-qa
1486 4c3d5fb6 Iustin Pop
pylint-qa: $(GENERATED_FILES)
1487 6e4c8f68 Iustin Pop
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1488 3582eef6 Iustin Pop
	cd $(top_srcdir)/qa && \
1489 3582eef6 Iustin Pop
	  PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1490 3582eef6 Iustin Pop
	  --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1491 e0098923 Iustin Pop
1492 6e4c8f68 Iustin Pop
.PHONY: pep8
1493 4c3d5fb6 Iustin Pop
pep8: $(GENERATED_FILES)
1494 6e4c8f68 Iustin Pop
	@test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1495 6e4c8f68 Iustin Pop
	$(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1496 6e4c8f68 Iustin Pop
		--repeat $(pep8_python_code)
1497 6e4c8f68 Iustin Pop
1498 2cdaf225 Iustin Pop
# FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1499 191ff68c Iustin Pop
.PHONY: hlint
1500 5a1e31b4 Iustin Pop
hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1501 6e4c8f68 Iustin Pop
	@test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1502 191ff68c Iustin Pop
	if tty -s; then C="-c"; else C=""; fi; \
1503 6e4c8f68 Iustin Pop
	$(HLINT) --report=doc/hs-lint.html --cross $$C \
1504 3603605a Iustin Pop
	  --ignore "Use first" \
1505 3603605a Iustin Pop
	  --ignore "Use comparing" \
1506 3603605a Iustin Pop
	  --ignore "Use on" \
1507 3603605a Iustin Pop
	  --ignore "Reduce duplication" \
1508 2cdaf225 Iustin Pop
	  --ignore "Use &&&" \
1509 2cdaf225 Iustin Pop
	  --ignore "Use void" \
1510 5a1e31b4 Iustin Pop
	  --hint htools/lint-hints \
1511 4ab40ed5 Iustin Pop
	  $(filter-out htools/Ganeti/THH.hs,$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1512 191ff68c Iustin Pop
1513 84a12e40 Iustin Pop
# a dist hook rule for updating the vcs-version file; this is
1514 84a12e40 Iustin Pop
# hardcoded due to where it needs to build the file...
1515 84a12e40 Iustin Pop
dist-hook:
1516 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1517 316dc1ff Iustin Pop
	rm -f $(top_distdir)/vcs-version
1518 84a12e40 Iustin Pop
	cp -p $(srcdir)/vcs-version $(top_distdir)
1519 84a12e40 Iustin Pop
1520 84a12e40 Iustin Pop
# a distcheck hook rule for catching revision control directories
1521 b6f2e47f Iustin Pop
distcheck-hook:
1522 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1523 c6aa0c42 Michael Hanselmann
		echo "Found revision control files in final archive." 1>&2; \
1524 c6aa0c42 Michael Hanselmann
		exit 1; \
1525 c6aa0c42 Michael Hanselmann
	fi
1526 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*.py[co]' | grep .; then \
1527 c6aa0c42 Michael Hanselmann
		echo "Found Python byte code in final archive." 1>&2; \
1528 c6aa0c42 Michael Hanselmann
		exit 1; \
1529 c6aa0c42 Michael Hanselmann
	fi
1530 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*~' | grep .; then \
1531 c6aa0c42 Michael Hanselmann
		echo "Found backup files in final archive." 1>&2; \
1532 b6f2e47f Iustin Pop
		exit 1; \
1533 b6f2e47f Iustin Pop
	fi
1534 bf0b21da Michael Hanselmann
# Empty files or directories should not be distributed. They can cause
1535 bf0b21da Michael Hanselmann
# unnecessary warnings for packagers. Directories used by automake during
1536 bf0b21da Michael Hanselmann
# distcheck must be excluded.
1537 bf0b21da Michael Hanselmann
	if find $(top_distdir) -empty -and -not \( \
1538 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_build -or \
1539 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_inst \) | grep .; then \
1540 bf0b21da Michael Hanselmann
		echo "Found empty files or directories in final archive." 1>&2; \
1541 bf0b21da Michael Hanselmann
		exit 1; \
1542 bf0b21da Michael Hanselmann
	fi
1543 c7b86f6c Michael Hanselmann
	if test -n "$(BUILD_RELEASE)" && \
1544 c7b86f6c Michael Hanselmann
	   grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1545 c7b86f6c Michael Hanselmann
		echo "Found unreleased version in NEWS." >&2; \
1546 c7b86f6c Michael Hanselmann
		exit 1; \
1547 c7b86f6c Michael Hanselmann
	fi
1548 c7b86f6c Michael Hanselmann
1549 c7b86f6c Michael Hanselmann
# When building a release, stricter checks should be used
1550 e627fe09 Michael Hanselmann
distcheck-release dist-release: export BUILD_RELEASE = 1
1551 c7b86f6c Michael Hanselmann
distcheck-release: distcheck
1552 b6f2e47f Iustin Pop
1553 7213dded René Nussbaumer
distrebuildcheck: dist
1554 7213dded René Nussbaumer
	set -e; \
1555 7213dded René Nussbaumer
	builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1556 7213dded René Nussbaumer
	trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1557 7213dded René Nussbaumer
	cd $$builddir; \
1558 7213dded René Nussbaumer
	tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1559 7213dded René Nussbaumer
	cd $(distdir); \
1560 7213dded René Nussbaumer
	./configure; \
1561 7213dded René Nussbaumer
	$(MAKE) maintainer-clean; \
1562 7213dded René Nussbaumer
	cp $(abs_srcdir)/vcs-version .; \
1563 7213dded René Nussbaumer
	./configure; \
1564 7213dded René Nussbaumer
	$(MAKE) $(AM_MAKEFLAGS)
1565 7213dded René Nussbaumer
1566 e627fe09 Michael Hanselmann
dist-release: dist
1567 e627fe09 Michael Hanselmann
	set -e; \
1568 e627fe09 Michael Hanselmann
	for i in $(DIST_ARCHIVES); do \
1569 e627fe09 Michael Hanselmann
		echo -n "Checking $$i ... "; \
1570 e627fe09 Michael Hanselmann
		autotools/check-tar < $$i; \
1571 e627fe09 Michael Hanselmann
		echo OK; \
1572 e627fe09 Michael Hanselmann
	done
1573 e627fe09 Michael Hanselmann
1574 8925faaa Iustin Pop
install-exec-local:
1575 0d93b082 Michael Hanselmann
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1576 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
1577 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/run/ganeti"
1578 e8230860 Michael Hanselmann
1579 d128fdb6 Iustin Pop
.PHONY: apidoc
1580 a38bfce5 Iustin Pop
if WANT_HTOOLSAPIDOC
1581 a38bfce5 Iustin Pop
apidoc: py-apidoc hs-apidoc
1582 a38bfce5 Iustin Pop
else
1583 a38bfce5 Iustin Pop
apidoc: py-apidoc
1584 a38bfce5 Iustin Pop
endif
1585 a38bfce5 Iustin Pop
1586 a38bfce5 Iustin Pop
.PHONY: py-apidoc
1587 4c3d5fb6 Iustin Pop
py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1588 b959138f Michael Hanselmann
	$(RUN_IN_TEMPDIR) epydoc -v \
1589 b959138f Michael Hanselmann
		--conf $(CURDIR)/epydoc.conf \
1590 22c5390d Iustin Pop
		--output $(CURDIR)/$(APIDOC_PY_DIR)
1591 a38bfce5 Iustin Pop
1592 a38bfce5 Iustin Pop
.PHONY: hs-apidoc
1593 c3f67183 Iustin Pop
hs-apidoc: $(HS_BUILT_SRCS)
1594 a38bfce5 Iustin Pop
	@test -n "$(HSCOLOUR)" || \
1595 a38bfce5 Iustin Pop
	    { echo 'HsColour' not found during configure; exit 1; }
1596 a38bfce5 Iustin Pop
	@test -n "$(HADDOCK)" || \
1597 a38bfce5 Iustin Pop
	    { echo 'haddock' not found during configure; exit 1; }
1598 22c5390d Iustin Pop
	rm -rf $(APIDOC_HS_DIR)/*
1599 879d9290 Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Backend
1600 458a286a Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1601 358a0a8f Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1602 4cbe9bda Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Query
1603 22c5390d Iustin Pop
	$(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1604 82888134 Michael Hanselmann
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1605 358a0a8f Iustin Pop
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1606 a38bfce5 Iustin Pop
	set -e ; \
1607 a38bfce5 Iustin Pop
	cd htools; \
1608 c478f837 Iustin Pop
	if [ "$(HTOOLS_NOCURL)" ]; \
1609 c478f837 Iustin Pop
	then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1610 c478f837 Iustin Pop
	else OPTGHC=""; \
1611 c478f837 Iustin Pop
	fi; \
1612 1adec4be Iustin Pop
	if [ "$(HTOOLS_PARALLEL3)" ]; \
1613 1adec4be Iustin Pop
	then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1614 1adec4be Iustin Pop
	fi; \
1615 21a5e56c Iustin Pop
	if [ "$(HTOOLS_REGEX_PCRE)" ]; \
1616 21a5e56c Iustin Pop
	then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_REGEX_PCRE)"; \
1617 21a5e56c Iustin Pop
	fi; \
1618 b88fcdd0 Iustin Pop
	RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1619 a38bfce5 Iustin Pop
	for file in $$RELSRCS; do \
1620 a38bfce5 Iustin Pop
		hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1621 22c5390d Iustin Pop
		$(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1622 a38bfce5 Iustin Pop
	done ; \
1623 22c5390d Iustin Pop
	$(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1624 18049dad Iustin Pop
		-t ganeti -p haddock-prologue \
1625 a38bfce5 Iustin Pop
		--source-module="%{MODULE/.//}.html" \
1626 a38bfce5 Iustin Pop
		--source-entity="%{MODULE/.//}.html#%{NAME}" \
1627 c478f837 Iustin Pop
		$$OPTGHC \
1628 c3f67183 Iustin Pop
		$(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1629 d128fdb6 Iustin Pop
1630 13e720f1 Iustin Pop
.PHONY: TAGS
1631 4c3d5fb6 Iustin Pop
TAGS: $(GENERATED_FILES)
1632 13e720f1 Iustin Pop
	rm -f TAGS
1633 6b84f036 Iustin Pop
	$(GHC) -e ":etags" -v0 \
1634 6b84f036 Iustin Pop
	  $(filter-out -O -Werror,$(HFLAGS)) \
1635 21a5e56c Iustin Pop
	  $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
1636 6b84f036 Iustin Pop
	  $(HS_LIBTEST_SRCS)
1637 74fa8200 Iustin Pop
	find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1638 74fa8200 Iustin Pop
	  -path './daemons/ganeti-*' -o -path './tools/*' -o \
1639 74fa8200 Iustin Pop
	  -path './qa/*.py' | \
1640 2db53645 Iustin Pop
	  etags -l python -a -
1641 13e720f1 Iustin Pop
1642 27e336af Michael Hanselmann
.PHONY: coverage
1643 b91e9518 Iustin Pop
if WANT_HTOOLS
1644 b91e9518 Iustin Pop
coverage: py-coverage hs-coverage
1645 b91e9518 Iustin Pop
else
1646 b91e9518 Iustin Pop
coverage: py-coverage
1647 b91e9518 Iustin Pop
endif
1648 b91e9518 Iustin Pop
1649 b91e9518 Iustin Pop
.PHONY: py-coverage
1650 4c3d5fb6 Iustin Pop
py-coverage: $(GENERATED_FILES) $(python_tests)
1651 141c8421 Michael Hanselmann
	@test -n "$(PYCOVERAGE)" || \
1652 141c8421 Michael Hanselmann
	    { echo 'python-coverage' not found during configure; exit 1; }
1653 27e336af Michael Hanselmann
	set -e; \
1654 141c8421 Michael Hanselmann
	COVERAGE=$(PYCOVERAGE) \
1655 22c5390d Iustin Pop
	COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1656 22c5390d Iustin Pop
	TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1657 22c5390d Iustin Pop
	HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1658 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1659 e8c8cf1a Michael Hanselmann
	$(python_tests)
1660 27e336af Michael Hanselmann
1661 b91e9518 Iustin Pop
.PHONY: hs-coverage
1662 f0f3a6df Iustin Pop
hs-coverage: $(haskell_tests) htest/hpc-htools
1663 316dc1ff Iustin Pop
	rm -f *.tix
1664 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) hs-check
1665 48f12e73 Iustin Pop
	@mkdir_p@ $(COVERAGE_HS_DIR)
1666 96eccc1f Iustin Pop
	hpc combine --union $(HPCEXCL) \
1667 96eccc1f Iustin Pop
	  test.tix hpc-htools.tix > coverage-htools.tix
1668 896b2850 Iustin Pop
	hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1669 896b2850 Iustin Pop
	hpc report coverage-htools.tix
1670 82888134 Michael Hanselmann
	$(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1671 b91e9518 Iustin Pop
1672 ec8379bd Iustin Pop
# Special "kind-of-QA" target for htools, needs special setup (all
1673 ec8379bd Iustin Pop
# tools compiled with -fhpc)
1674 ec8379bd Iustin Pop
.PHONY: live-test
1675 ec8379bd Iustin Pop
live-test: all
1676 ec8379bd Iustin Pop
	set -e ; \
1677 ec8379bd Iustin Pop
	cd htools; \
1678 82888134 Michael Hanselmann
	rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1679 ec8379bd Iustin Pop
	rm -f *.tix *.mix; \
1680 ec8379bd Iustin Pop
	./live-test.sh; \
1681 c3f67183 Iustin Pop
	hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1682 ec8379bd Iustin Pop
	  --output=live-test.tix ; \
1683 22c5390d Iustin Pop
	@mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1684 22c5390d Iustin Pop
	hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1685 ec8379bd Iustin Pop
		--srcdir=.. $(HPCEXCL) ; \
1686 ec8379bd Iustin Pop
	hpc report --srcdir=.. live-test $(HPCEXCL)
1687 b91e9518 Iustin Pop
1688 b341b9ca Guido Trotter
commit-check: distcheck lint apidoc
1689 b341b9ca Guido Trotter
1690 6438e259 Iustin Pop
.PHONY: gitignore-check
1691 6438e259 Iustin Pop
gitignore-check:
1692 6438e259 Iustin Pop
	@if [ -n "`git status --short`" ]; then \
1693 6438e259 Iustin Pop
	  echo "Git status is not clean!" 1>&2 ; \
1694 6438e259 Iustin Pop
	  git status --short; \
1695 6438e259 Iustin Pop
	  exit 1; \
1696 6438e259 Iustin Pop
	fi
1697 6438e259 Iustin Pop
1698 37519c09 Iustin Pop
# Target that builds all binaries (including those that are not
1699 37519c09 Iustin Pop
# rebuilt except when running the tests)
1700 37519c09 Iustin Pop
.PHONY: really-all
1701 37519c09 Iustin Pop
really-all: all $(check_SCRIPTS) $(haskell_tests)
1702 37519c09 Iustin Pop
1703 1d45f7a0 Iustin Pop
# we don't need the ancient implicit rules:
1704 1d45f7a0 Iustin Pop
%: %,v
1705 1d45f7a0 Iustin Pop
%: RCS/%,v
1706 1d45f7a0 Iustin Pop
%: RCS/%
1707 1d45f7a0 Iustin Pop
%: s.%
1708 1d45f7a0 Iustin Pop
%: SCCS/s.%
1709 1d45f7a0 Iustin Pop
1710 3baa809c Michael Hanselmann
-include ./Makefile.local
1711 3baa809c Michael Hanselmann
1712 e8230860 Michael Hanselmann
# vim: set noet :